/*  GadTools layout toolkit
**
**  Copyright  1993-1994 by Olaf `Olsen' Barthel
**  Freely distributable.
*/

#include "gtlayout_global.h"

struct Menu * __stdargs
LT_LayoutMenus(LayoutHandle *handle,struct NewMenu *menuTemplate,...)
{
	struct Menu	*Result;
	va_list 	 VarArgs;

	va_start(VarArgs,menuTemplate);
	Result = LT_LayoutMenusA(handle,menuTemplate,(struct TagItem *)VarArgs);
	va_end(VarArgs);

	return(Result);
}

struct Menu * LIBENT
LT_LayoutMenusA(REG(a0) LayoutHandle *handle,REG(a1) struct NewMenu *menuTemplate,REG(a2) struct TagItem *TagParams)
{
	struct Menu *menu;

	menu = NULL;

	if(handle)
	{
		struct TagItem	*tag;
		LONG		 label;
		BOOLEAN 	 foundFirst;
		BOOLEAN 	 foundLast;
		LONG		*Table = NULL;

		foundFirst	= FALSE;
		foundLast	= FALSE;

		if(tag = FindTagItem(LA_LabelTable,(struct TagItem *)TagParams))
			Table = (LONG *)tag -> ti_Data;

		if(tag = FindTagItem(LA_FirstLabel,(struct TagItem *)TagParams))
		{
			foundFirst = TRUE;

			label = tag -> ti_Data;
		}

		if(tag = FindTagItem(LA_LastLabel,(struct TagItem *)TagParams))
			foundLast = TRUE;

		if(foundFirst == foundLast || Table)
		{
			struct NewMenu *localTemplate;

			localTemplate = NULL;

			if(Table)
			{
				foundFirst = FALSE;

				if(handle -> LocaleHook)
				{
					LONG count;

					count = 0;

					while(menuTemplate[count] . nm_Type != NM_END)
						count++;

					count++;

					if(localTemplate = AllocVec(sizeof(struct NewMenu) * count,MEMF_ANY | MEMF_PUBLIC))
					{
						LONG i;

						CopyMem(menuTemplate,localTemplate,sizeof(struct NewMenu) * count);

						for(i = 0 ; i < count ; i++)
						{
							if(localTemplate[i] . nm_Label != NM_BARLABEL && (localTemplate[i] . nm_Type == NM_TITLE || localTemplate[i] . nm_Type == NM_ITEM || localTemplate[i] . nm_Type == NM_SUB))
								localTemplate[i] . nm_Label = (STRPTR)CallHookPkt(handle -> LocaleHook,handle,(APTR)(*Table++));
						}
					}
				}

				menuTemplate = localTemplate;
			}

			if(foundFirst)
			{
				if(handle -> LocaleHook)
				{
					LONG count;

					count = 0;

					while(menuTemplate[count] . nm_Type != NM_END)
						count++;

					count++;

					if(localTemplate = AllocVec(sizeof(struct NewMenu) * count,MEMF_ANY | MEMF_PUBLIC))
					{
						LONG i;

						CopyMem(menuTemplate,localTemplate,sizeof(struct NewMenu) * count);

						for(i = 0 ; i < count ; i++)
						{
							if(localTemplate[i] . nm_Label != NM_BARLABEL && (localTemplate[i] . nm_Type == NM_TITLE || localTemplate[i] . nm_Type == NM_ITEM || localTemplate[i] . nm_Type == NM_SUB))
							{
								localTemplate[i] . nm_Label = (STRPTR)CallHookPkt(handle -> LocaleHook,handle,(APTR)label);

								label++;
							}
						}
					}
				}

				menuTemplate = localTemplate;
			}

			if(menuTemplate)
			{
				if(menu = CreateMenusA(menuTemplate,NULL))
				{
					if(!LayoutMenus(menu,handle -> VisualInfo,
						GTMN_NewLookMenus,	TRUE,

						handle -> AmigaGlyph ? GTMN_AmigaKey :	TAG_IGNORE,handle -> AmigaGlyph,
						handle -> CheckGlyph ? GTMN_Checkmark : TAG_IGNORE,handle -> CheckGlyph,
					TAG_DONE))
					{
						FreeMenus(menu);

						menu = NULL;
					}
				}

				if(localTemplate)
					FreeVec(localTemplate);
			}
		}
	}

	return(menu);
}
