/*  GadTools layout toolkit
**
**  Copyright  1993-1994 by Olaf `Olsen' Barthel
**  Freely distributable.
*/

#include "gtlayout_global.h"

VOID __regargs
LTP_DetermineSize(LayoutHandle *Handle,ObjectNode *Node)
{
	if(!Handle -> Failed)
	{
		LONG i,Len,Width,Max;

		if(Node -> Label)
			Node -> LabelWidth = LT_LabelWidth(Handle,Node -> Label);
		else
			Node -> LabelWidth = 0;

		switch(Node -> Type)
		{
#ifdef DO_LEVEL_KIND
			case LEVEL_KIND:

				Node -> Width	= 6 + Node -> Chars * Handle -> GlyphWidth + 6;
				Node -> Height	= 2 + Handle -> RPort . TxHeight + 1;

				if((!Node -> Special . Level . MaxLevelWidth || Handle -> Rescaled))
				{
					LT_LevelWidth(Handle,Node -> Special . Level . LevelFormat,Node -> Special . Level . DispFunc,Node -> Special . Level . Min,Node -> Special . Level . Max,&Node -> Special . Level . MaxLevelWidth,NULL,Node -> Special . Level . FullLevelCheck);

					Node -> Special . Level . MaxLevelWidth += TextLength(&Handle -> RPort," ",1);
				}

				Node -> Special . Level . Handle		= Handle;
				Node -> Special . Level . CustomHook . h_Entry	= (HOOKFUNC)LTP_LevelGadgetDispatcher;

				if(!Node -> Special . Level . Plus)
					Node -> Special . Level . Plus = Node -> Special . Level . Min;

				if(Node -> Special . Level . LevelPlace == PLACETEXT_LEFT)
					Node -> LabelWidth += Node -> Special . Level . MaxLevelWidth;

				break;
#endif	/* DO_LEVEL_KIND */
			case GROUP_KIND:

				LTP_LayoutGroup(Handle,Node);

				break;

			case XBAR_KIND:

				Node -> Width	= Handle -> GlyphWidth;
				Node -> Height	= 6;

				break;

			case YBAR_KIND:

				Node -> Width	= 6;
				Node -> Height	= Handle -> RPort . TxHeight;

				break;

			case FRAME_KIND:

				if(Node -> Special . Frame . DrawBox)
				{
					Node -> Width	= 4 + Node -> Special . Frame . InnerWidth + 4;
					Node -> Height	= 2 + Node -> Special . Frame . InnerHeight + 2;
				}
				else
				{
					Node -> Width	= Node -> Special . Frame . InnerWidth;
					Node -> Height	= Node -> Special . Frame . InnerHeight;
				}

				break;

			case BOX_KIND:

				Node -> LabelWidth = 0;

				if(Node -> Special . Box . Labels)
				{
					for(i = 0 ; i < Node -> Lines ; i++)
					{
						if((Width = TextLength(&Handle -> RPort,Node -> Special . Box . Labels[i],strlen(Node -> Special . Box . Labels[i]))) > Node -> LabelWidth)
							Node -> LabelWidth = Width;
					}
				}

				Max = Node -> Chars;

				if(Node -> Special . Box . Lines)
				{
					LONG MaxWidth = 0;

					for(i = 0 ; i < Node -> Lines ; i++)
					{
						if(Node -> Special . Box . Lines[i])
						{
							if(Len = strlen(Node -> Special . Box . Lines[i]))
							{
								if((Width = TextLength(&Handle -> RPort,Node -> Special . Box . Lines[i],Len)) > MaxWidth)
									MaxWidth = Width;
							}
						}
					}

					if(Max < (MaxWidth + Handle -> GlyphWidth - 1) / Handle -> GlyphWidth)
						Max = (MaxWidth + Handle -> GlyphWidth - 1) / Handle -> GlyphWidth;
				}

				Node -> Height	= 2 + Node -> Lines * Handle -> RPort . TxHeight + 2;
				Node -> Width	= 4 + Max * Handle -> GlyphWidth + 4;

				break;

			case BUTTON_KIND:

				if(Node -> Chars * Handle -> GlyphWidth > Node -> LabelWidth)
					Node -> Width = Node -> Chars * Handle -> GlyphWidth;
				else
					Node -> Width = Node -> LabelWidth;

				Node -> LabelWidth = 0;
				Node -> LabelPlace = PLACE_IN;

				if(Node -> Special . Button . ExtraFat)
				{
					Node -> Width	= 6 + Handle -> GlyphWidth + Node -> Width + Handle -> GlyphWidth + 6;
					Node -> Height	= 2 + (3 * Handle -> RPort . TxHeight) / 2 + 2;
				}
				else
				{
					Node -> Width	= 6 + Node -> Width + 6;
					Node -> Height	= 3 + Handle -> RPort . TxHeight + 3;
				}

				break;

			case CHECKBOX_KIND:

				Node -> Width = Node -> Height = (4 * Handle -> RPort . TxHeight) / 3;

				if(!V39)
				{
					if(Node -> Width < CHECKBOX_WIDTH)
						Node -> Width = CHECKBOX_WIDTH;

					if(Node -> Height < CHECKBOX_HEIGHT)
						Node -> Height = CHECKBOX_HEIGHT;
				}
				else
				{
					Node -> Width = (Node -> Width * Handle -> AspectY) / Handle -> AspectX;

					if(Node -> Height < CHECKBOX_HEIGHT)
					{
						Node -> Height	= CHECKBOX_HEIGHT;
						Node -> Width	= (Node -> Height * Handle -> AspectY) / Handle -> AspectX;
					}
				}

				break;

			case LISTVIEW_KIND:

				i	= 0;
				Max	= 0;
				Width	= Node -> Chars * Handle -> GlyphWidth;

				if(Node -> Special . List . Labels)
				{
					struct Node *Item;

					SCANLIST(Node -> Special . List . Labels,Item)
					{
						i++;

						if((Len = TextLength(&Handle -> RPort,Item -> ln_Name,strlen(Item -> ln_Name))) > Max)
							Max = Len;
					}
				}

				Node -> Max = i - 1;

				if(Max > Width)
				{
					Width = Max;

					Node -> Chars = Width / Handle -> GlyphWidth;
				}

				if(!V39)
					Node -> Width = (4 + Width + 4) + (2 + 2 * Handle -> GlyphWidth + 2) + 8;
				else
					Node -> Width = (4 + Width + 4) + (2 + 2 * Handle -> GlyphWidth + 2);

				Node -> Height = 2 + Node -> Lines * Handle -> RPort . TxHeight + 2;

				if(Node -> Special . List . ReadOnly)
				{
					if(Node -> Special . List . LinkID != -1)
					{
						if(!V39)
							Node -> Height += 2 + Handle -> RPort . TxHeight + 2;
					}
				}
				else
				{
					if(Node -> Special . List . LinkID != -1 && Node -> Special . List . LinkID != NIL_LINK)
						Node -> Height += 3 + Handle -> RPort . TxHeight + 3;
				}

				if(Node -> Special . List . ExtraLabels)
				{
					for(i = Max = 0 ; Node -> Special . List . ExtraLabels[i] ; i++)
					{
						if((Len = TextLength(&Handle -> RPort,Node -> Special . List . ExtraLabels[i],strlen(Node -> Special . List . ExtraLabels[i]))) > Max)
							Max = Len;
					}

					Node -> Special . List . ExtraLabelWidth = Max;
				}

				if(Node -> LabelWidth > Node -> Width && (Node -> LabelPlace == PLACE_ABOVE || Node -> LabelPlace == PLACE_BELOW))
					Node -> Width = Node -> LabelWidth;

				break;

			case MX_KIND:

				i	= 0;
				Max	= 0;

				while(Node -> Special . Radio . Choices[i])
				{
					if((Width = TextLength(&Handle -> RPort,Node -> Special . Radio . Choices[i],strlen(Node -> Special . Radio . Choices[i]))) > Max)
						Max = Width;

					i++;
				}

				Node -> Max = i - 1;

				Node -> Special . Radio . LabelWidth = Max;

				Node -> Height = MAX(MX_HEIGHT,Handle -> RPort . TxHeight);

				if(!V39)
					Node -> Width = MX_WIDTH;
				else
				{
					Node -> Width = (Node -> Height * Handle -> AspectY) / Handle -> AspectX;

					if(Node -> Height < MX_HEIGHT)
					{
						Node -> Height = MX_HEIGHT;
						Node -> Width  = (Node -> Height * Handle -> AspectX) / Handle -> AspectY;
					}
				}

				Node -> Lines  = i;
				Node -> Height = Node -> Lines * (Node -> Height + Handle -> InterHeight) - Handle -> InterHeight;

				break;

			case TEXT_KIND:

				if(Node -> Special . Text . Text)
					Max = TextLength(&Handle -> RPort,Node -> Special . Text . Text,strlen(Node -> Special . Text . Text));
				else
					Max = 0;

				Width = Node -> Chars * Handle -> GlyphWidth;

				if(Max > Width)
					Width = Max;

				Node -> Width	= 6 + Width + 6;
				Node -> Height	= 3 + Handle -> RPort . TxHeight + 3;

				if(Node -> Special . Text . UsePicker)
					Node -> Width += (4 + (Handle -> GlyphWidth & ~1) + 1 + 4);

				if(Node -> LabelWidth > Node -> Width && (Node -> LabelPlace == PLACE_ABOVE || Node -> LabelPlace == PLACE_BELOW))
					Node -> Width = Node -> LabelWidth;

				break;

#ifdef DO_GAUGE_KIND
			case GAUGE_KIND:

				Width = TextLength(&Handle -> RPort,"0% 100%",7);

				if(Handle -> GlyphWidth * Node -> Chars > Width)
					Width = Handle -> GlyphWidth * Node -> Chars;

				Node -> Width	= 6 + Width + 6;
				Node -> Height	= 3 + Handle -> RPort . TxHeight + 2 + Handle -> InterHeight + Handle -> RPort . TxHeight + 3;

				if(Node -> Label)
					Node -> LabelWidth = LT_LabelWidth(Handle,Node -> Label);
				else
					Node -> LabelWidth = 0;

				if(Node -> LabelWidth > Node -> Width && (Node -> LabelPlace == PLACE_ABOVE || Node -> LabelPlace == PLACE_BELOW))
					Node -> Width = Node -> LabelWidth;

				break;
#endif

#ifdef DO_TAPEDECK_KIND
			case TAPEDECK_KIND:
			{
				LONG Width,Height;

				Width = TextLength(&Handle -> RPort,"AA",2);

				if(Width < 2 * Handle -> GlyphWidth);
					Width = 2 * Handle -> GlyphWidth;

				if(Width < 2 * Handle -> RPort . TxHeight)
					Width = 2 * Handle -> RPort . TxHeight;

				if(Node -> Special . TapeDeck . Smaller)
					Width = (3 * Width) / 4;

				if(Width & 1)
					Width++;

				Width	= 1 + ((((Width + 5) / 6) * 6) & ~1);
				Height	= (Handle -> AspectX * Width) / (Handle -> AspectY * 2);

				if(!(Height & 1))
					Height++;

				if(Node -> Special . TapeDeck . ButtonType == TDBT_BACKWARD || Node -> Special . TapeDeck . ButtonType == TDBT_FORWARD)
					Node -> Special . TapeDeck . ButtonWidth = Width;
				else
					Node -> Special . TapeDeck . ButtonWidth = Width / 2;

				Node -> Special . TapeDeck . ButtonHeight = Height;

				if(Handle -> GlyphWidth * Node -> Chars > Width)
					Width = Handle -> GlyphWidth * Node -> Chars;

				Node -> Width	= 6 + Width + 6;
				Node -> Height	= 3 + Height + 3;

				if(Node -> LabelWidth > Node -> Width && (Node -> LabelPlace == PLACE_ABOVE || Node -> LabelPlace == PLACE_BELOW))
					Node -> Width = Node -> LabelWidth;

				break;
			}
#endif	/* DO_TAPEDECK_KIND */

			case NUMBER_KIND:

				Node -> Width	= 6 + Node -> Chars * Handle -> GlyphWidth + 6;
				Node -> Height	= 2 + Handle -> RPort . TxHeight + 2;

				break;

			case CYCLE_KIND:

				Width = Node -> Chars * Handle -> GlyphWidth;

				if(Node -> Special . Cycle . Choices)
				{
					for(i = 0 ; Node -> Special . Cycle . Choices[i] ; i++)
					{
						if((Len = TextLength(&Handle -> RPort,Node -> Special . Cycle . Choices[i],strlen(Node -> Special . Cycle . Choices[i]))) > Width)
							Width = Len;
					}

					Node -> Max = i - 1;
				}

				Node -> Width	= 26 + Width + 6;
				Node -> Height	= 3 + Handle -> RPort . TxHeight + 3;

				if(Node -> LabelWidth > Node -> Width && (Node -> LabelPlace == PLACE_ABOVE || Node -> LabelPlace == PLACE_BELOW))
					Node -> Width = Node -> LabelWidth;

				break;

			case PALETTE_KIND:

				if(Node -> Special . Palette . NumColours)
					Node -> Max = Node -> Min + Node -> Special . Palette . NumColours - 1;
				else
				{
					if(!Node -> Special . Palette . Depth)
						Node -> Special . Palette . Depth = 1;

					Node -> Special . Palette . NumColours = 1L << Node -> Special . Palette . Depth;

					Node -> Max = Node -> Min + Node -> Special . Palette . NumColours - 1;
				}

				if(Node -> Special . Palette . SmallPalette)
				{
					Node -> Width	= Handle -> GlyphWidth * (Node -> Max - Node -> Min + 1);
					Node -> Height	= 1 + Handle -> RPort . TxHeight + 1;
				}
				else
				{
					Node -> Width	= 2 * Handle -> GlyphWidth * (Node -> Max - Node -> Min + 1);
					Node -> Height	= 2 * Handle -> RPort . TxHeight;
				}

				if(Node -> Chars * Handle -> GlyphWidth > Node -> Width)
					Node -> Width = Node -> Chars * Handle -> GlyphWidth;

				if(Node -> Special . Palette . NumColours > 16)
				{
					Node -> Height *= 2;
					Node -> Width	/= 2;
				}

				if(Node -> Lines)
				{
					if(!Node -> Chars)
						Node -> Width = Handle -> GlyphWidth;
					else
						Node -> Width = Node -> Chars * Handle -> GlyphWidth;

					Node -> Height	= Node -> Lines * Handle -> RPort . TxHeight;
				}

				break;

			case SCROLLER_KIND:

				if(Node -> Special . Scroller . Vertical)
				{
					if(Node -> Special . Scroller . Thin)
						Node -> Width = 6 + Handle -> GlyphWidth + 6;
					else
						Node -> Width = 6 + (3 * Handle -> GlyphWidth) / 2 + 6;

					Node -> Height = 2 + Node -> Lines * Handle -> RPort . TxHeight;

					if(Node -> Special . Scroller . Arrows)
					{
						WORD ScrollerHeight = (Handle -> AspectX * Node -> Width) / Handle -> AspectY;

						if(Node -> Height < 2 + Node -> Lines * Handle -> RPort . TxHeight + 2 * ScrollerHeight)
							Node -> Height = 2 + Node -> Lines * Handle -> RPort . TxHeight + 2 * ScrollerHeight;

						Node -> Special . Scroller . ArrowSize = ScrollerHeight;
					}
				}
				else
				{
					Node -> Width  = 6 + Node -> Chars * Handle -> GlyphWidth + 6;
					Node -> Height = 2 + Handle -> RPort . TxHeight;

					if(Node -> Special . Scroller . Arrows)
					{
						WORD ScrollerWidth = (Handle -> AspectY * Node -> Height) / Handle -> AspectX;

						if(Node -> Width < 6 + Handle -> GlyphWidth + 2 * ScrollerWidth + 6)
							Node -> Width = 6 + Handle -> GlyphWidth + 2 * ScrollerWidth + 6;

						Node -> Special . Scroller . ArrowSize = ScrollerWidth;
					}
				}

				if(Node -> LabelWidth > Node -> Width && (Node -> LabelPlace == PLACE_ABOVE || Node -> LabelPlace == PLACE_BELOW))
					Node -> Width = Node -> LabelWidth;

				break;

			case SLIDER_KIND:
			{
				BOOLEAN CheckIt;

				Node -> Width	= 6 + Node -> Chars * Handle -> GlyphWidth + 6;
				Node -> Height	= 2 + Handle -> RPort . TxHeight + 1;

				CheckIt = (!Node -> Special . Slider . MaxLevelLen || !Node -> Special . Slider . LevelWidth || Handle -> Rescaled);

				if(CheckIt)
					LT_LevelWidth(Handle,Node -> Special . Slider . LevelFormat,Node -> Special . Slider . DispFunc,Node -> Min,Node -> Max,&Node -> Special . Slider . LevelWidth,&Node -> Special . Slider . MaxLevelLen,Node -> Special . Slider . FullLevelCheck);

				if(!V40)
				{
					if(Node -> Special . Slider . MaxLevelLen * Handle -> RPort . TxWidth < Node -> Special . Slider . LevelWidth)
						Node -> Special . Slider . MaxLevelLen = (Node -> Special . Slider . LevelWidth + Handle -> RPort . TxWidth - 1) / Handle -> RPort . TxWidth;
				}

				if(Node -> Special . Slider . LevelPlace == PLACETEXT_LEFT && Node -> LabelPlace == PLACE_LEFT && Node -> Label && CheckIt)
				{
					LONG	space,len;
					STRPTR	Buffer;

					space = TextLength(&Handle -> RPort," ",1);
					space = (Node -> Special . Slider . LevelWidth + space - 1) / space;

					if(!V40 && (Handle -> RPort . TxFlags & FPF_PROPORTIONAL))
					{
						Node -> Special . Slider . MaxLevelLen++;

						space++;
					}

					if(Node -> Special . Slider . OriginalLabel)
						LTP_Free(Handle,Node -> Label,strlen(Node -> Label) + 1);
					else
						Node -> Special . Slider . OriginalLabel = Node -> Label;

					len = strlen(Node -> Special . Slider . OriginalLabel);

					if(Buffer = LTP_Alloc(Handle,len + space + 1))
					{
						strcpy(Buffer,Node -> Special . Slider . OriginalLabel);

						while(space > 0)
						{
							Buffer[len] = ' ';
							len++;
							space--;
						}

						Buffer[len] = 0;

						Node -> Label		= Buffer;
						Node -> LabelWidth	= LT_LabelWidth(Handle,Node -> Label);
					}
					else
						break;
				}

				if(Node -> LabelWidth > Node -> Width && (Node -> LabelPlace == PLACE_ABOVE || Node -> LabelPlace == PLACE_BELOW))
					Node -> Width = Node -> LabelWidth;

				break;
			}

			case STRING_KIND:

				Node -> Width	= 6 + Node -> Chars * Handle -> GlyphWidth + 6;
				Node -> Height	= 3 + Handle -> RPort . TxHeight + 3;

				if(Node -> Special . String . UsePicker)
					Node -> Width += (4 + (Handle -> GlyphWidth & ~1) + 1 + 4);

				if(Node -> LabelWidth > Node -> Width && (Node -> LabelPlace == PLACE_ABOVE || Node -> LabelPlace == PLACE_BELOW))
					Node -> Width = Node -> LabelWidth;

				break;

			case INTEGER_KIND:

				Node -> Width	= 6 + Node -> Chars * Handle -> GlyphWidth + 6;
				Node -> Height	= 3 + Handle -> RPort . TxHeight + 3;

				if(Node -> Special . Integer . UseIncrementers)
				{
					Node -> Width += 4 + Handle -> GlyphWidth + 4;
					Node -> Width += 4 + Handle -> GlyphWidth + 4;
				}

				if(Node -> LabelWidth > Node -> Width && (Node -> LabelPlace == PLACE_ABOVE || Node -> LabelPlace == PLACE_BELOW))
					Node -> Width = Node -> LabelWidth;

				break;

			case PASSWORD_KIND:
			case FRACTION_KIND:

				Node -> Width	= 6 + Node -> Chars * Handle -> GlyphWidth + 6;
				Node -> Height	= 3 + Handle -> RPort . TxHeight + 3;

				if(Node -> LabelWidth > Node -> Width && (Node -> LabelPlace == PLACE_ABOVE || Node -> LabelPlace == PLACE_BELOW))
					Node -> Width = Node -> LabelWidth;

				break;
		}
	}
}
