/*  GadTools layout toolkit
**
**  Copyright  1993-1994 by Olaf `Olsen' Barthel
**  Freely distributable.
*/

#include "gtlayout_global.h"

#ifdef DO_TAPEDECK_KIND
VOID __regargs
LTP_DrawPrevNext(struct RastPort *RPort,BOOLEAN Prev,LONG Left,LONG Top,LONG Width,LONG Height)
{
	LONG i,Len,Start,ArrowWidth,ArrowHeight,LineWidth;

	LineWidth	= (Width + 15) / 16;
	ArrowWidth	= Width;
	ArrowHeight	= Height;
	Left		= Left - (LineWidth / 2);

	if(Prev)
	{
		for(i = 0 ; i < ArrowWidth ; i++)
		{
			Len	= ((ArrowHeight * (i + 1)) / ArrowWidth) & ~1;

			if(Len < ArrowHeight)
				Len++;

			Start	= Top + (ArrowHeight - Len) / 2;

			Move(RPort,Left + i,Start);
			Draw(RPort,Left + i,Start + Len - 1);
		}

		for(i = 0 ; i < LineWidth ; i++)
		{
			Move(RPort,Left + i,Top);
			Draw(RPort,Left + i,Top + Height - 1);
		}
	}
	else
	{
		for(i = 0 ; i < ArrowWidth ; i++)
		{
			Len	= ((ArrowHeight * (i + 1)) / ArrowWidth) & ~1;

			if(Len < ArrowHeight)
				Len++;

			Start	= Top + (ArrowHeight - Len) / 2;

			Move(RPort,Left + ArrowWidth - 1 - i,Start);
			Draw(RPort,Left + ArrowWidth - 1 - i,Start + Len - 1);
		}

		for(i = 0 ; i < LineWidth ; i++)
		{
			Move(RPort,Left + ArrowWidth - 1 - i,Top);
			Draw(RPort,Left + ArrowWidth - 1 - i,Top + Height - 1);
		}
	}
}
#endif	/* DO_TAPEDECK_KIND */
