/*  GadTools layout toolkit
**
**  Copyright  1993-1994 by Olaf `Olsen' Barthel
**  Freely distributable.
*/

#include "gtlayout_global.h"

VOID __regargs
LTP_PlaceGroups(LayoutHandle *handle,ObjectNode *group,LONG left,LONG top)
{
	if(!handle -> Failed)
	{
		ObjectNode	*node;
		LONG		 plusLeft,
				 plusTop,
				 lastSpace;

		if(group -> Label)
		{
			plusLeft	= 4 + handle -> GlyphWidth + handle -> InterWidth + group -> Special . Group . ExtraLeft;
			plusTop 	= handle -> RPort . TxHeight + handle -> InterHeight + group -> Special . Group . ExtraTop;
		}
		else
		{
			plusLeft	= group -> Special . Group . ExtraLeft;
			plusTop 	= group -> Special . Group . ExtraTop;
		}

		if(group -> ExtraSpace)
		{
			if(group -> Special . Group . ParentGroup -> Special . Group . Horizontal)
				left += handle -> InterWidth;
			else
				top += handle -> InterHeight;
		}

		group -> Left	= left;
		group -> Top	= top;

		left	+= plusLeft;
		top	+= plusTop;

		if(group -> Special . Group . Horizontal)
		{
			lastSpace = left;

			SCANGROUP(group,node)
			{
				if(node -> Type == GROUP_KIND)
					LTP_PlaceGroups(handle,node,lastSpace,top);
				else
				{
					node -> Left	+= left;
					node -> Top	+= top;

					handle -> Count++;
				}

				if(!group -> Special . Group . Paging)
				{
					lastSpace = node -> Left + node -> Width + handle -> InterWidth;

					if(node -> Type == MX_KIND)
					{
						if((node -> LabelPlace == PLACETEXT_RIGHT) || (node -> LabelPlace == PLACETEXT_LEFT))
							lastSpace += INTERWIDTH + node -> Special . Radio . LabelWidth;
					}
				}

				if(node -> Centered)
				{
					// !!! needs to be smarter about object height,dealing with labels,and the like

					node -> Top = group -> Top + ((group -> Height - node -> Height) / 2);
				}
			}
		}
		else
		{
			lastSpace = top;

			SCANGROUP(group,node)
			{
				if(node -> Type == GROUP_KIND)
					LTP_PlaceGroups(handle,node,left,lastSpace);
				else
				{
					node -> Left	+= left;
					node -> Top	+= top;

					handle -> Count++;
				}

				if(!group -> Special . Group . Paging)
					lastSpace = node -> Top + node -> Height + handle -> InterHeight;

				if(node -> Centered)
				{
					// !!! needs to be smarter about object widths,like for MX_KIND
					node -> Left = group -> Left + ((group -> Width - node -> Width) / 2);
				}
			}
		}
	}
}
