/*
**	CommandPanel.c
**
**	Editing panel for command sequences
**
**	Copyright  1990-1994 by Olaf `Olsen' Barthel
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_USE=1000,GAD_CANCEL,GAD_DEFAULT };

BYTE __regargs
CommandPanel(struct Configuration *Config,BYTE *Default)
{
	struct LayoutHandle	*Handle;
	BYTE			 Cancel = FALSE;

	SaveConfig(Config,PrivateConfig);

	if(Handle = LT_CreateHandleTags(Window -> WScreen,
		LH_LocaleHook,	&LocaleHook,
	TAG_DONE))
	{
		struct Window *PanelWindow;

		LT_New(Handle,
			LA_Type,	VERTICAL_KIND,
		TAG_DONE);
		{
			LT_New(Handle,
				LA_Type,	VERTICAL_KIND,
				LA_LabelID,	MSG_V36_0026,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	STRING_KIND,
					LA_LabelID,	MSG_COMMANDPANEL_STARTUP_LOGIN_MACRO_GAD,
					LA_STRPTR,	Config -> CommandConfig -> StartupMacro,
					LA_Chars,	30,
					GTST_MaxChars,	255,
				TAG_DONE);

				LT_New(Handle,LA_Type,XBAR_KIND,TAG_DONE);

				LT_New(Handle,
					LA_Type,	STRING_KIND,
					LA_LabelID,	MSG_COMMANDPANEL_LOGIN_MACRO_GAD,
					LA_STRPTR,	Config -> CommandConfig -> LoginMacro,
					LA_Chars,	30,
					GTST_MaxChars,	255,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	STRING_KIND,
					LA_LabelID,	MSG_COMMANDPANEL_LOGOFF_MACRO_GAD,
					LA_STRPTR,	Config -> CommandConfig -> LogoffMacro,
					GTST_MaxChars,	255,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,		VERTICAL_KIND,
				LA_LabelID,		MSG_V36_0027,
				LAGR_LastAttributes,	TRUE,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	STRING_KIND,
					LA_LabelID,	MSG_COMMANDPANEL_UPLOAD_MACRO_GAD,
					LA_STRPTR,	Config -> CommandConfig -> UploadMacro,
					LA_Chars,	30,
					GTST_MaxChars,	255,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	STRING_KIND,
					LA_LabelID,	MSG_COMMANDPANEL_DOWNLOAD_MACRO_GAD,
					LA_STRPTR,	Config -> CommandConfig -> DownloadMacro,
					GTST_MaxChars,	255,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,VERTICAL_KIND,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	XBAR_KIND,
					LAXB_FullSize,	TRUE,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,LA_Type,HORIZONTAL_KIND,
				LAGR_SameSize,	TRUE,
				LAGR_Spread,	TRUE,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_USE_GAD,
					LA_ID,		GAD_USE,
					LABT_ReturnKey,	TRUE,
					LABT_ExtraFat,	TRUE,
				TAG_DONE);

				if(Default)
				{
					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_GLOBAL_DEFAULT_GAD,
						LA_ID,		GAD_DEFAULT,
						LABT_ExtraFat,	TRUE,
					TAG_DONE);
				}

				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_CANCEL_GAD,
					LA_ID,		GAD_CANCEL,
					LABT_EscKey,	TRUE,
					LABT_ExtraFat,	TRUE,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_EndGroup(Handle);
		}

		if(PanelWindow = LT_Layout(Handle,LocaleString(MSG_COMMANDPANEL_COMMAND_PREFERENCES_GAD),NULL,0,0,IDCMP_CLOSEWINDOW,0,
			LAWN_HelpHook,		&GuideHook,
			LAWN_Parent,		Window,
			WA_DepthGadget,		TRUE,
			WA_CloseGadget,		TRUE,
			WA_DragBar,		TRUE,
			WA_RMBTrap,		TRUE,
			WA_Activate,		TRUE,
		TAG_DONE))
		{
			struct IntuiMessage	*Message;
			BOOLEAN			 Done = FALSE;
			ULONG			 MsgClass,
						 MsgQualifier;
			UWORD			 MsgCode;
			struct Gadget		*MsgGadget;

			GuideContext(CONTEXT_COMMAND);

			PushWindow(PanelWindow);

			LT_ShowWindow(Handle,TRUE);

			do
			{
				if(Wait(PORTMASK(PanelWindow -> UserPort) | SIG_BREAK) & SIG_BREAK)
				{
					SaveConfig(PrivateConfig,Config);

					break;
				}

				while(Message = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort))
				{
					MsgClass	= Message -> Class;
					MsgQualifier	= Message -> Qualifier;
					MsgCode		= Message -> Code;
					MsgGadget	= (struct Gadget *)Message -> IAddress;

					GT_ReplyIMsg(Message);

					LT_HandleInput(Handle,MsgQualifier,&MsgClass,&MsgCode,&MsgGadget);

					if(MsgClass == IDCMP_CLOSEWINDOW)
					{
						SaveConfig(PrivateConfig,Config);

						Done = TRUE;
					}

					if(MsgClass == IDCMP_GADGETUP)
					{
						switch(MsgGadget -> GadgetID)
						{
							case GAD_USE:

								Done = TRUE;
								break;

							case GAD_CANCEL:

								SaveConfig(PrivateConfig,Config);

								Cancel = Done = TRUE;
								break;

							case GAD_DEFAULT:

								*Default = TRUE;

								Done = TRUE;
								break;
						}
					}
				}
			}
			while(!Done);

			PopWindow();
		}

		LT_DeleteHandle(Handle);
	}

	if(Default)
		return((BYTE)(!Cancel));
	else
		return((BYTE)memcmp(PrivateConfig -> CommandConfig,Config -> CommandConfig,sizeof(struct CommandSettings)));
}
