/*
**	DatePanel.c
**
**	Editing panel for date selection
**
**	Copyright  1990-1994 by Olaf `Olsen' Barthel
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_MONTH=1,GAD_DAY,GAD_COMMENT,GAD_USE,GAD_CANCEL };

STATIC STRPTR __saveds
ShowMonth(struct Gadget *SomeGadget,WORD Level)
{
	return(LocaleString(Level + MSG_DATEPANEL_JANUARY_TXT));
}

BYTE __regargs
DatePanel(struct TimeDateNode *Node)
{
	STATIC BYTE MaxDays[12] = { 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

	struct LayoutHandle	*Handle;
	struct TimeDateNode	 LocalNode;
	BYTE			 Result = FALSE;

	LocalNode = *Node;

	if(Handle = LT_CreateHandleTags(Window -> WScreen,
		LH_LocaleHook,	&LocaleHook,
	TAG_DONE))
	{
		struct Window *PanelWindow;

		LT_New(Handle,
			LA_Type,	VERTICAL_KIND,
		TAG_DONE);
		{
			LT_New(Handle,
				LA_Type,	VERTICAL_KIND,
				LA_LabelID,	MSG_V36_0032,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,		SliderType,
					LA_LabelID,		MSG_DATEPANEL_MONTH_GAD,
					LA_HighLabel,		TRUE,
					LA_BYTE,		&LocalNode . Header . Month,
					LA_ID,			GAD_MONTH,
					LA_Chars,		16,
					GTSL_Max,		11,
					GTSL_LevelFormat,	"%s",
					GTSL_DispFunc,		ShowMonth,
					LASL_FullCheck,		TRUE,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,		SliderType,
					LA_LabelID,		MSG_DATEPANEL_DAY_GAD,
					LA_HighLabel,		TRUE,
					LA_BYTE,		&LocalNode . Header . Day,
					LA_ID,			GAD_DAY,
					GTSL_Min,		1,
					GTSL_Max,		MaxDays[LocalNode . Header . Month],
					LASL_FullCheck,		TRUE,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	XBAR_KIND,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	STRING_KIND,
					LA_LabelID,	MSG_GLOBAL_COMMENT_GAD,
					LA_STRPTR,	LocalNode . Header . Comment,
					GTST_MaxChars,	19,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,VERTICAL_KIND,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	XBAR_KIND,
					LAXB_FullSize,	TRUE,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,LA_Type,HORIZONTAL_KIND,
				LAGR_SameSize,	TRUE,
				LAGR_Spread,	TRUE,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_USE_GAD,
					LA_ID,		GAD_USE,
					LABT_ReturnKey,	TRUE,
					LABT_ExtraFat,	TRUE,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_CANCEL_GAD,
					LA_ID,		GAD_CANCEL,
					LABT_EscKey,	TRUE,
					LABT_ExtraFat,	TRUE,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_EndGroup(Handle);
		}

		if(PanelWindow = LT_Layout(Handle,LocaleString(MSG_DATEPANEL_DATE_SETTINGS_TXT),NULL,0,0,IDCMP_CLOSEWINDOW,0,
			LAWN_HelpHook,		&GuideHook,
			LAWN_Parent,		Window,
			WA_DepthGadget,		TRUE,
			WA_CloseGadget,		TRUE,
			WA_DragBar,		TRUE,
			WA_RMBTrap,		TRUE,
			WA_Activate,		TRUE,
		TAG_DONE))
		{
			struct IntuiMessage	*Message;
			BOOLEAN			 Done = FALSE;
			ULONG			 MsgClass,
						 MsgQualifier;
			UWORD			 MsgCode;
			struct Gadget		*MsgGadget;

			GuideContext(CONTEXT_DATE);

			LT_ShowWindow(Handle,TRUE);

			PushWindow(PanelWindow);

			do
			{
				if(Wait(PORTMASK(PanelWindow -> UserPort) | SIG_BREAK) & SIG_BREAK)
					break;

				while(Message = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort))
				{
					MsgClass	= Message -> Class;
					MsgQualifier	= Message -> Qualifier;
					MsgCode		= Message -> Code;
					MsgGadget	= (struct Gadget *)Message -> IAddress;

					GT_ReplyIMsg(Message);

					LT_HandleInput(Handle,MsgQualifier,&MsgClass,&MsgCode,&MsgGadget);

					if(MsgClass == IDCMP_CLOSEWINDOW)
						Done = TRUE;

					if(MsgClass == IDCMP_MOUSEMOVE && MsgGadget -> GadgetID == GAD_MONTH)
					{
						LT_SetAttributes(Handle,GAD_DAY,
							GTSL_Max,	MaxDays[LocalNode . Header . Month],
						TAG_DONE);
					}

					if(MsgClass == IDCMP_GADGETUP)
					{
						switch(MsgGadget -> GadgetID)
						{
							case GAD_USE:

								*Node = LocalNode;

								Result = Done = TRUE;

								break;

							case GAD_CANCEL:

								Done = TRUE;
								break;
						}
					}
				}
			}
			while(!Done);

			PopWindow();
		}

		LT_DeleteHandle(Handle);
	}

	return(Result);
}
