/*
**	FastMacroPanel.c
**
**	Editing panel for fast! macros
**
**	Copyright  1990-1994 by Olaf `Olsen' Barthel
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_LIST,GAD_MACRO,GAD_CODE,
		GAD_TOP,GAD_UP,GAD_DOWN,GAD_END,
		GAD_NEW,GAD_REMOVE,GAD_CLEAR,
		GAD_LOAD,GAD_SAVE,GAD_USE
	};

BOOLEAN __regargs
FastMacroPanel(struct List *FastMacroList,STRPTR LastFastMacros,struct Window *Parent)
{
	struct LayoutHandle	*Handle;
	BOOLEAN			 FastMacrosChanged = FALSE;

	if(Handle = LT_CreateHandleTags(Window -> WScreen,
		LH_LocaleHook,	&LocaleHook,
	TAG_DONE))
	{
		struct Window	*FastWindow;
		struct IBox	 Bounds;

		LT_New(Handle,
			LA_Type,	VERTICAL_KIND,
		TAG_DONE);
		{
			LT_New(Handle,
				LA_Type,	VERTICAL_KIND,
				LA_LabelID,	MSG_V36_0037,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	LISTVIEW_KIND,
					LA_LabelID,	MSG_FASTMACROPANEL_MACRO_LIST_GAD,
					LA_LabelPlace,	PLACE_LEFT,
					LA_Chars,	30,
					LA_Lines,	10,
					LA_ID,		GAD_LIST,
					LALV_CursorKey,	TRUE,
					LALV_MaxGrowY,	20,
					LALV_MaxGrowX,	50,
					GTLV_Labels,	FastMacroList,

					Kick30 ? LALV_Link : TAG_IGNORE, NIL_LINK,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	STRING_KIND,
					LA_LabelID,	MSG_FASTMACROPANEL_MACRO_GAD,
					LA_ID,		GAD_MACRO,
					GTST_MaxChars,	20,
					GA_Disabled,	TRUE,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	STRING_KIND,
					LA_LabelID,	MSG_FASTMACROPANEL_MACRO_TEXT_GAD,
					LA_ID,		GAD_CODE,
					GTST_MaxChars,	255,
					GA_Disabled,	TRUE,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,	HORIZONTAL_KIND,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	HORIZONTAL_KIND,
					LA_LabelID,	MSG_V36_0038,
					LA_Spread,	TRUE,
					LA_SameSize,	TRUE,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelText,	"|<",
						LA_ID,		GAD_TOP,
						LA_NoKey,	TRUE,
						GA_Disabled,	TRUE,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelText,	"<",
						LA_ID,		GAD_UP,
						LA_NoKey,	TRUE,
						GA_Disabled,	TRUE,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelText,	">",
						LA_ID,		GAD_DOWN,
						LA_NoKey,	TRUE,
						GA_Disabled,	TRUE,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelText,	">|",
						LA_ID,		GAD_END,
						LA_NoKey,	TRUE,
						GA_Disabled,	TRUE,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_New(Handle,
					LA_Type,	HORIZONTAL_KIND,
					LA_LabelID,	MSG_V36_0043,
					LA_Spread,	TRUE,
					LA_SameSize,	TRUE,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_FASTMACROPANEL_NEW_GAD,
						LA_ID,		GAD_NEW,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_GLOBAL_REMOVE_GAD,
						LA_ID,		GAD_REMOVE,
						GA_Disabled,	TRUE,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_UPLOADQUEUE_CLEAR_TXT,
						LA_ID,		GAD_CLEAR,
						GA_Disabled,	FastMacroList -> lh_Head -> ln_Succ == NULL,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,	VERTICAL_KIND,
			TAG_DONE);
			{
				LT_New(Handle,LA_Type,XBAR_KIND,LAXB_FullSize,TRUE,TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,LA_Type,HORIZONTAL_KIND,
				LAGR_SameSize,	TRUE,
				LAGR_Spread,	TRUE,
				LA_ExtraSpace,	TRUE,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_USE_GAD,
					LA_ID,		GAD_USE,
					LABT_ReturnKey,	TRUE,
					LABT_ExtraFat,	TRUE,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_LOAD_GAD,
					LA_ID,		GAD_LOAD,
					LABT_ExtraFat,	TRUE,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_SAVE_GAD,
					LA_ID,		GAD_SAVE,
					LABT_ExtraFat,	TRUE,
					GA_Disabled,	FastMacroList -> lh_Head -> ln_Succ == NULL,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_EndGroup(Handle);
		}

		if(Screen && Window)
		{
			Bounds . Left	= Window -> LeftEdge;
			Bounds . Top	= Window -> TopEdge;
			Bounds . Width	= Window -> Width;
			Bounds . Height	= Window -> Height;
		}

		if(FastWindow = LT_Layout(Handle,LocaleString(MSG_FASTMACROPANEL_FAST_MACRO_PREFERENCES_TXT),Screen ? &Bounds : NULL,0,0,IDCMP_CLOSEWINDOW,0,
			LAWN_HelpHook,		&GuideHook,
			LAWN_Parent,		Parent,
			WA_DepthGadget,		TRUE,
			WA_CloseGadget,		TRUE,
			WA_DragBar,		TRUE,
			WA_RMBTrap,		TRUE,
			WA_Activate,		TRUE,
		TAG_DONE))
		{
			struct IntuiMessage	*Message;
			BOOLEAN			 Done = FALSE;
			ULONG			 MsgClass,
						 MsgQualifier;
			UWORD			 MsgCode;
			struct Gadget		*MsgGadget;

			struct MacroNode	*Node,*Selected = NULL;
			ULONG			 Offset = 0;

			UBYTE		 	 DummyBuffer[MAX_FILENAME_LENGTH],
						*DummyChar;
			struct FileRequester	*FileRequest;

			GuideContext(CONTEXT_FASTMACROS);

			PushWindow(FastWindow);

			LT_ShowWindow(Handle,TRUE);

			do
			{
				if(Wait(PORTMASK(FastWindow -> UserPort) | SIG_BREAK) & SIG_BREAK)
					break;

				while(Message = (struct IntuiMessage *)GT_GetIMsg(FastWindow -> UserPort))
				{
					MsgClass	= Message -> Class;
					MsgQualifier	= Message -> Qualifier;
					MsgCode		= Message -> Code;
					MsgGadget	= (struct Gadget *)Message -> IAddress;

					GT_ReplyIMsg(Message);

					LT_HandleInput(Handle,MsgQualifier,&MsgClass,&MsgCode,&MsgGadget);

					if(MsgClass == IDCMP_CLOSEWINDOW)
						Done = TRUE;

					if(MsgClass == IDCMP_GADGETUP)
					{
						switch(MsgGadget -> GadgetID)
						{
							case GAD_USE:

								Done = TRUE;
								break;

							case GAD_TOP:

								LT_SetAttributes(Handle,GAD_LIST,
									GTLV_Labels,	~0,
								TAG_DONE);

								Remove((struct Node *)Selected);

								AddHead(FastMacroList,(struct Node *)Selected);

								RefreshFastWindow(TRUE);

								Offset = 0;

								LT_SetAttributes(Handle,GAD_LIST,
									GTLV_Labels,	FastMacroList,
									GTLV_Selected,	Offset,
									GTLV_Top,	Offset,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_TOP,
									GA_Disabled,	TRUE,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_UP,
									GA_Disabled,	TRUE,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_DOWN,
									GA_Disabled,	!Selected -> mn_Succ -> mn_Succ,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_END,
									GA_Disabled,	!Selected -> mn_Succ -> mn_Succ,
								TAG_DONE);

								FastMacrosChanged = TRUE;

								break;

							case GAD_UP:

								LT_SetAttributes(Handle,GAD_LIST,
									GTLV_Labels,	~0,
								TAG_DONE);

								Node = Selected -> mn_Pred -> mn_Pred;

								Remove((struct Node *)Selected);

								Insert(FastMacroList,(struct Node *)Selected,(struct Node *)Node);

								RefreshFastWindow(TRUE);

								Offset--;

								LT_SetAttributes(Handle,GAD_LIST,
									GTLV_Labels,	FastMacroList,
									GTLV_Selected,	Offset,
									GTLV_Top,	Offset,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_TOP,
									GA_Disabled,	!Selected -> mn_Pred -> mn_Pred,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_UP,
									GA_Disabled,	!Selected -> mn_Pred -> mn_Pred,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_DOWN,
									GA_Disabled,	!Selected -> mn_Succ -> mn_Succ,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_END,
									GA_Disabled,	!Selected -> mn_Succ -> mn_Succ,
								TAG_DONE);

								FastMacrosChanged = TRUE;

								break;

							case GAD_DOWN:

								LT_SetAttributes(Handle,GAD_LIST,
									GTLV_Labels,	~0,
								TAG_DONE);

								Node = Selected -> mn_Succ;

								Remove((struct Node *)Selected);

								Insert(FastMacroList,(struct Node *)Selected,(struct Node *)Node);

								RefreshFastWindow(TRUE);

								Offset++;

								LT_SetAttributes(Handle,GAD_LIST,
									GTLV_Labels,	FastMacroList,
									GTLV_Selected,	Offset,
									GTLV_Top,	Offset,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_TOP,
									GA_Disabled,	!Selected -> mn_Pred -> mn_Pred,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_UP,
									GA_Disabled,	!Selected -> mn_Pred -> mn_Pred,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_DOWN,
									GA_Disabled,	!Selected -> mn_Succ -> mn_Succ,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_END,
									GA_Disabled,	!Selected -> mn_Succ -> mn_Succ,
								TAG_DONE);

								FastMacrosChanged = TRUE;

								break;

							case GAD_END:

								LT_SetAttributes(Handle,GAD_LIST,
									GTLV_Labels,	~0,
								TAG_DONE);

								Remove((struct Node *)Selected);

								AddTail(FastMacroList,(struct Node *)Selected);

								RefreshFastWindow(TRUE);

								Offset = FastMacroCount - 1;

								LT_SetAttributes(Handle,GAD_LIST,
									GTLV_Labels,	FastMacroList,
									GTLV_Selected,	Offset,
									GTLV_Top,	Offset,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_TOP,
									GA_Disabled,	!Selected -> mn_Pred -> mn_Pred,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_UP,
									GA_Disabled,	!Selected -> mn_Pred -> mn_Pred,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_DOWN,
									GA_Disabled,	!Selected -> mn_Succ -> mn_Succ,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_END,
									GA_Disabled,	!Selected -> mn_Succ -> mn_Succ,
								TAG_DONE);

								FastMacrosChanged = TRUE;

								break;

							case GAD_NEW:

								if(Node = NewFastMacro(LocaleString(MSG_FASTMACROPANEL_UNNAMED_TXT),""))
								{
									LT_SetAttributes(Handle,GAD_LIST,
										GTLV_Labels,	~0,
									TAG_DONE);

									AddTail(FastMacroList,(struct Node *)Node);

									RefreshFastWindow(TRUE);

									LT_SetAttributes(Handle,GAD_LIST,
										GTLV_Labels,	FastMacroList,
										GTLV_Selected,	FastMacroCount++,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_CODE,
										GTST_String,	"",
										GA_Disabled,	FALSE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_MACRO,
										GTST_String,	Node -> mn_Macro,
										GA_Disabled,	FALSE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_REMOVE,
										GA_Disabled,	FALSE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_SAVE,
										GA_Disabled,	FALSE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_CLEAR,
										GA_Disabled,	FALSE,
									TAG_DONE);

									Selected = Node;

									Offset = MsgCode;

									LT_SetAttributes(Handle,GAD_TOP,
										GA_Disabled,	!Selected -> mn_Pred -> mn_Pred,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_UP,
										GA_Disabled,	!Selected -> mn_Pred -> mn_Pred,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_DOWN,
										GA_Disabled,	!Selected -> mn_Succ -> mn_Succ,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_END,
										GA_Disabled,	!Selected -> mn_Succ -> mn_Succ,
									TAG_DONE);

									LT_Activate(Handle,GAD_MACRO);

									FastMacrosChanged = TRUE;
								}
								else
									DisplayBeep(FastWindow -> WScreen);

								break;

							case GAD_CLEAR:

								LT_SetAttributes(Handle,GAD_LIST,
									GTLV_Labels,	~0,
								TAG_DONE);

								FreeList(FastMacroList);

								RefreshFastWindow(TRUE);

								FastMacroCount = 0;
								
								LT_SetAttributes(Handle,GAD_LIST,
									GTLV_Labels,	FastMacroList,
									GTLV_Selected,	~0,
								TAG_DONE);

								Selected = NULL;

								LT_SetAttributes(Handle,GAD_TOP,
									GA_Disabled,	TRUE,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_UP,
									GA_Disabled,	TRUE,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_DOWN,
									GA_Disabled,	TRUE,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_END,
									GA_Disabled,	TRUE,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_REMOVE,
									GA_Disabled,	TRUE,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_MACRO,
									GTST_String,	"",
									GA_Disabled,	TRUE,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_CODE,
									GTST_String,	"",
									GA_Disabled,	TRUE,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_SAVE,
									GA_Disabled,	TRUE,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_CLEAR,
									GA_Disabled,	TRUE,
								TAG_DONE);

								FastMacrosChanged = FALSE;

								break;

							case GAD_REMOVE:

								if(Selected)
								{
									LT_SetAttributes(Handle,GAD_LIST,
										GTLV_Labels,	~0,
									TAG_DONE);

									if(--FastMacroCount)
									{
										if(Selected -> mn_Succ -> mn_Succ)
											Node = Selected -> mn_Succ;
										else
										{
											Node = Selected -> mn_Pred;

											Offset = 0;
										}
									}

									FreeNode((struct Node *)Selected);

									RefreshFastWindow(TRUE);

									LT_SetAttributes(Handle,GAD_LIST,
										GTLV_Labels,	FastMacroList,
										GTLV_Selected,	Node -> mn_Succ ? GetNodeOffset((struct Node *)Node,FastMacroList) : ~0,
									TAG_DONE);

									if(!FastMacroCount)
									{
										Selected = NULL;

										LT_SetAttributes(Handle,GAD_TOP,
											GA_Disabled,	TRUE,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_UP,
											GA_Disabled,	TRUE,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_DOWN,
											GA_Disabled,	TRUE,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_END,
											GA_Disabled,	TRUE,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_REMOVE,
											GA_Disabled,	TRUE,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_MACRO,
											GTST_String,	"",
											GA_Disabled,	TRUE,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_CODE,
											GTST_String,	"",
											GA_Disabled,	TRUE,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_SAVE,
											GA_Disabled,	TRUE,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_CLEAR,
											GA_Disabled,	TRUE,
										TAG_DONE);
									}
									else
									{
										Selected = Node;

										LT_SetAttributes(Handle,GAD_CODE,
											GTST_String,	Selected -> mn_Code,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_MACRO,
											GTST_String,	Selected -> mn_Macro,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_TOP,
											GA_Disabled,	!Selected -> mn_Pred -> mn_Pred,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_UP,
											GA_Disabled,	!Selected -> mn_Pred -> mn_Pred,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_DOWN,
											GA_Disabled,	!Selected -> mn_Succ -> mn_Succ,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_END,
											GA_Disabled,	!Selected -> mn_Succ -> mn_Succ,
										TAG_DONE);
									}

									FastMacrosChanged = TRUE;
								}

								break;

							case GAD_LIST:

								if(Selected = (struct MacroNode *)GetListNode(MsgCode,FastMacroList))
								{
									Offset = MsgCode;

									LT_SetAttributes(Handle,GAD_MACRO,
										GTST_String,	Selected -> mn_Macro,
										GA_Disabled,	FALSE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_CODE,
										GTST_String,	Selected -> mn_Code,
										GA_Disabled,	FALSE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_REMOVE,
										GA_Disabled,	FALSE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_TOP,
										GA_Disabled,	!Selected -> mn_Pred -> mn_Pred,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_UP,
										GA_Disabled,	!Selected -> mn_Pred -> mn_Pred,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_DOWN,
										GA_Disabled,	!Selected -> mn_Succ -> mn_Succ,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_END,
										GA_Disabled,	!Selected -> mn_Succ -> mn_Succ,
									TAG_DONE);
								}

								break;

							case GAD_MACRO:

								if(Selected)
								{
									LT_SetAttributes(Handle,GAD_LIST,
										GTLV_Labels,	~0,
									TAG_DONE);

									strcpy(Selected -> mn_Macro,(STRPTR)LT_GetAttributes(Handle,GAD_MACRO,TAG_DONE));

									RefreshFastWindow(TRUE);

									LT_SetAttributes(Handle,GAD_LIST,
										GTLV_Labels,	FastMacroList,
										GTLV_Selected,	GetNodeOffset((struct Node *)Selected,FastMacroList),
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_CODE,
										GTST_String,	Selected -> mn_Code,
									TAG_DONE);

									FastMacrosChanged = TRUE;

									LT_Activate(Handle,GAD_CODE);
								}

								break;

							case GAD_CODE:

								if(Selected)
								{
									strcpy(Selected -> mn_Code,(STRPTR)LT_GetAttributes(Handle,GAD_CODE,TAG_DONE));

									FastMacrosChanged = TRUE;
								}

								break;

							case GAD_LOAD:

								SplitFileName(LastFastMacros,&DummyChar,DummyBuffer);

								LT_LockWindow(FastWindow);

								if(FileRequest = GetFile(FastWindow,LocaleString(MSG_FASTMACROPANEL_LOAD_FAST_MACRO_SETTINGS_TXT),DummyBuffer,FilePart(LastFastMacros),DummyBuffer,"#?.prefs",FALSE,FALSE,FALSE,LocaleString(MSG_GLOBAL_LOAD_TXT),TRUE))
								{
									LT_SetAttributes(Handle,GAD_LIST,
										GTLV_Labels,	~0,
									TAG_DONE);

									Selected = NULL;

									if(!LoadFastMacros(DummyBuffer,FastMacroList))
										ShowError(FastWindow,ERR_LOAD_ERROR,IoErr(),DummyBuffer);
									else
									{
										strcpy(Config -> FileConfig -> FastMacroFileName,DummyBuffer);

										strcpy(LastFastMacros,DummyBuffer);

										FastMacrosChanged = FALSE;
									}

									LT_SetAttributes(Handle,GAD_LIST,
										GTLV_Labels,	FastMacroList,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_CODE,
										GTST_String,	"",
										GA_Disabled,	TRUE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_MACRO,
										GTST_String,	"",
										GA_Disabled,	TRUE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_REMOVE,
										GA_Disabled,	TRUE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_TOP,
										GA_Disabled,	TRUE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_UP,
										GA_Disabled,	TRUE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_DOWN,
										GA_Disabled,	TRUE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_END,
										GA_Disabled,	TRUE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_SAVE,
										GA_Disabled,	!FastMacroCount,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_CLEAR,
										GA_Disabled,	!FastMacroCount,
									TAG_DONE);

									RefreshFastWindow(TRUE);

									FreeAslRequest(FileRequest);
								}

								LT_UnlockWindow(FastWindow);

								break;

							case GAD_SAVE:

								SplitFileName(LastFastMacros,&DummyChar,DummyBuffer);

								LT_LockWindow(FastWindow);

								if(FileRequest = GetFile(FastWindow,LocaleString(MSG_FASTMACROPANEL_SAVE_FAST_MACRO_SETTINGS_TXT),DummyBuffer,FilePart(LastFastMacros),DummyBuffer,"#?.prefs",TRUE,FALSE,FALSE,LocaleString(MSG_GLOBAL_SAVE_TXT),TRUE))
								{
									if(!SaveFastMacros(DummyBuffer,FastMacroList))
										ShowError(FastWindow,ERR_SAVE_ERROR,IoErr(),DummyBuffer);
									else
									{
										strcpy(LastFastMacros,DummyBuffer);

										FastMacrosChanged = FALSE;
									}

									FreeAslRequest(FileRequest);
								}

								LT_UnlockWindow(FastWindow);

								break;
						}
					}
				}
			}
			while(!Done);

			PopWindow();
		}

		LT_DeleteHandle(Handle);
	}

	return(FastMacrosChanged);
}
