/*
**	LibPanel.c
**
**	Editing panel for transfer library configuration
**
**	Copyright  1990-1994 by Olaf `Olsen' Barthel
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_DEFAULT_LIB=1000,
		GAD_ASCII_UPLOAD_LIB,GAD_ASCII_DOWNLOAD_LIB,
		GAD_TEXT_UPLOAD_LIB,GAD_TEXT_DOWNLOAD_LIB,
		GAD_BINARY_UPLOAD_LIB,GAD_BINARY_DOWNLOAD_LIB,
		GAD_MANGLE,GAD_INTERNAL_ASCII_PREFS,
		GAD_NOTIFY_AFTER_N_ERRORS,GAD_NOTIFY_WHEN,
		GAD_USE,GAD_CANCEL,GAD_DEFAULT,

		GAD_DEFAULT_PREFS,
		GAD_ASCII_UPLOAD_PREFS,GAD_ASCII_DOWNLOAD_PREFS,
		GAD_TEXT_UPLOAD_PREFS,GAD_TEXT_DOWNLOAD_PREFS,
		GAD_BINARY_UPLOAD_PREFS,GAD_BINARY_DOWNLOAD_PREFS
	};

STATIC STRPTR __saveds
ShowTime(struct Gadget *SomeGadget,WORD Level)
{
	return(LocaleSeconds(Level));
}

STATIC VOID __regargs
ASCIITransferPanel(struct Window *Window,struct Configuration *Config)
{
	struct TransferSettings	 OldSettings;

	struct LayoutHandle	*Handle;

	CopyMem(Config -> TransferConfig,&OldSettings,sizeof(struct TransferSettings));

	if(Handle = LT_CreateHandleTags(Window -> WScreen,
		LH_LocaleHook,	&LocaleHook,
	TAG_DONE))
	{
		struct Window *PanelWindow;

		LT_New(Handle,
			LA_Type,	VERTICAL_KIND,
		TAG_DONE);
		{
			LT_New(Handle,
				LA_Type,	VERTICAL_KIND,
				LA_LabelID,	MSG_INTERNAL_ASCII_TRANSFER_SEND_TXT,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	VERTICAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	CYCLE_KIND,
						LA_LabelID,	MSG_CLIPPANEL_TEXT_PACING_GAD,
						LA_UBYTE,	&Config -> TransferConfig -> PacingMode,
						LACY_FirstLabel,MSG_CLIPPANEL_DIRECT_TXT,
						LACY_LastLabel,	MSG_CLIPPANEL_KEYDELAY_TXT,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_New(Handle,
					LA_Type,	VERTICAL_KIND,
					LA_LabelID,	MSG_V36_0021,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,		SliderType,
						LA_LabelID,		MSG_CLIPPANEL_CHAR_DELAY_GAD,
						GTSL_Min,		0,
						GTSL_Max,		10 * 100,
						LA_Chars,		10,
						LA_WORD,		&Config -> TransferConfig -> CharDelay,
						GTSL_LevelFormat,	"%s s",
						GTSL_DispFunc,		ShowTime,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,		SliderType,
						LA_LabelID,		MSG_CLIPPANEL_LINE_DELAY_GAD,
						GTSL_Min,		0,
						GTSL_Max,		10 * 100,
						LA_Chars,		10,
						LA_WORD,		&Config -> TransferConfig -> LineDelay,
						GTSL_LevelFormat,	"%s s",
						GTSL_DispFunc,		ShowTime,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_New(Handle,
					LA_Type,	VERTICAL_KIND,
					LA_LabelID,	MSG_V36_0024,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,		STRING_KIND,
						LA_LabelID,		MSG_CLIPPANEL_LINE_PROMPT_GAD,
						LA_STRPTR,		Config -> TransferConfig -> LinePrompt,
						LA_Chars,		10,
						GTST_MaxChars,		255,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,		SliderType,
						LA_LabelID,		MSG_CLIPPANEL_SEND_TIMEOUT_GAD,
						GTSL_Min,		0,
						GTSL_Max,		10 * 100,
						LA_WORD,		&Config -> TransferConfig -> SendTimeout,
						GTSL_LevelFormat,	"%s s",
						GTSL_DispFunc,		ShowTime,
					TAG_DONE);

					LT_EndGroup(Handle);
				}


				LT_New(Handle,
					LA_Type,	VERTICAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	CYCLE_KIND,
						LA_LabelID,	MSG_TERMINALPANEL_SEND_CR_GAD,
						LA_BYTE,	&Config -> TransferConfig -> SendCR,
						GTCY_Labels,	EOL_Labels,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	CYCLE_KIND,
						LA_LabelID,	MSG_TERMINALPANEL_SEND_LF_GAD,
						LA_BYTE,	&Config -> TransferConfig -> SendLF,
						GTCY_Labels,	EOL_Labels,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,	VERTICAL_KIND,
				LA_LabelID,	MSG_INTERNAL_ASCII_TRANSFER_RECEIVE_TXT,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	CYCLE_KIND,
					LA_LabelID,	MSG_TERMINALPANEL_RECEIVE_CR_GAD,
					LA_BYTE,	&Config -> TransferConfig -> ReceiveCR,
					GTCY_Labels,	EOL_Labels,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	CYCLE_KIND,
					LA_LabelID,	MSG_TERMINALPANEL_RECEIVE_LF_GAD,
					LA_BYTE,	&Config -> TransferConfig -> ReceiveLF,
					GTCY_Labels,	EOL_Labels,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	CHECKBOX_KIND,
					LA_LabelID,	MSG_INTERNAL_ASCII_TRANSFER_IGNORE_DATA_PAST_ARNOLD_TXT,
					LA_BYTE,	&Config -> TransferConfig -> IgnoreDataPastArnold,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	INTEGER_KIND,
					LA_LabelID,	MSG_INTERNAL_ASCII_TRANSFER_TERMINATOR_CHAR_TXT,
					LA_BYTE,	&Config -> TransferConfig -> TerminatorChar,
					LAIN_Min,	0,
					LAIN_Max,	255,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,	VERTICAL_KIND,
				LA_LabelID,	MSG_INTERNAL_ASCII_TRANSFER_GENERAL_TXT,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	CHECKBOX_KIND,
					LA_LabelID,	MSG_LIBPANEL_QUIET_TRANSFER_GAD,
					LA_BYTE,	&Config -> TransferConfig -> QuietTransfer,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	CHECKBOX_KIND,
					LA_LabelID,	MSG_INTERNAL_ASCII_TRANSFER_STRIP_BIT_7_TXT,
					LA_BYTE,	&Config -> TransferConfig -> StripBit8,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,VERTICAL_KIND,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	XBAR_KIND,
					LAXB_FullSize,	TRUE,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,LA_Type,HORIZONTAL_KIND,
				LAGR_SameSize,	TRUE,
				LAGR_Spread,	TRUE,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_USE_GAD,
					LA_ID,		GAD_USE,
					LABT_ReturnKey,	TRUE,
					LABT_ExtraFat,	TRUE,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_CANCEL_GAD,
					LA_ID,		GAD_CANCEL,
					LABT_EscKey,	TRUE,
					LABT_ExtraFat,	TRUE,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_EndGroup(Handle);
		}

		if(PanelWindow = LT_Layout(Handle,LocaleString(MSG_INTERNAL_ASCII_TRANSFER_TRANSFER_TXT),NULL,0,0,IDCMP_CLOSEWINDOW,0,
			LAWN_HelpHook,		&GuideHook,
			LAWN_Parent,		Window,
			WA_DepthGadget,		TRUE,
			WA_CloseGadget,		TRUE,
			WA_DragBar,		TRUE,
			WA_RMBTrap,		TRUE,
			WA_Activate,		TRUE,
		TAG_DONE))
		{
			struct IntuiMessage	*Message;
			BOOLEAN			 Done = FALSE;
			ULONG			 MsgClass,
						 MsgQualifier;
			UWORD			 MsgCode;
			struct Gadget		*MsgGadget;

/*			GuideContext(CONTEXT_CLIP);*/

			PushWindow(PanelWindow);

			LT_ShowWindow(Handle,TRUE);

			do
			{
				if(Wait(PORTMASK(PanelWindow -> UserPort) | SIG_BREAK) & SIG_BREAK)
				{
					CopyMem(&OldSettings,Config -> TransferConfig,sizeof(struct TransferSettings));

					break;
				}

				while(Message = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort))
				{
					MsgClass	= Message -> Class;
					MsgQualifier	= Message -> Qualifier;
					MsgCode		= Message -> Code;
					MsgGadget	= (struct Gadget *)Message -> IAddress;

					GT_ReplyIMsg(Message);

					LT_HandleInput(Handle,MsgQualifier,&MsgClass,&MsgCode,&MsgGadget);

					if(MsgClass == IDCMP_CLOSEWINDOW)
					{
						CopyMem(&OldSettings,Config -> TransferConfig,sizeof(struct TransferSettings));

						Done = TRUE;
					}

					if(MsgClass == IDCMP_GADGETUP)
					{
						switch(MsgGadget -> GadgetID)
						{
							case GAD_USE:

								Done = TRUE;
								break;

							case GAD_CANCEL:

								CopyMem(&OldSettings,Config -> TransferConfig,sizeof(struct TransferSettings));

								Done = TRUE;
								break;
						}
					}
				}
			}
			while(!Done);

			PopWindow();
		}

		LT_DeleteHandle(Handle);
	}
}

BYTE __regargs
LibPanel(struct Configuration *Config,BYTE *Default)
{
	struct LayoutHandle	*Handle;
	BYTE			 OpenIt = TRUE,
				 Cancel = FALSE;

	SaveConfig(Config,PrivateConfig);

	if(Handle = LT_CreateHandleTags(Window -> WScreen,
		LH_LocaleHook,	&LocaleHook,
	TAG_DONE))
	{
		struct Window *PanelWindow;

		LT_New(Handle,
			LA_Type,	VERTICAL_KIND,
		TAG_DONE);
		{
			LT_New(Handle,
				LA_Type,	HORIZONTAL_KIND,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	STRING_KIND,
					LA_LabelID,	MSG_LIBPANEL_DEFAULT_TRANSFER_LIBRARY_GAD,
					LA_STRPTR,	Config -> TransferConfig -> DefaultLibrary,
					LA_Chars,	20,
					LA_ID,		GAD_DEFAULT_LIB,
					GTST_MaxChars,	MAX_FILENAME_LENGTH,
					LAST_Picker,	TRUE,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_LIBPANEL_PREFS_GAD,
					LA_ID,		GAD_DEFAULT_PREFS,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,	VERTICAL_KIND,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	CHECKBOX_KIND,
					LA_LabelID,	MSG_MANGLE_UPLOAD_FILENAMES_TXT,
					LA_BYTE,	&Config -> TransferConfig -> MangleFileNames,
					LA_ID,		GAD_MANGLE,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,		INTEGER_KIND,
					LA_LabelID,		MSG_NOTIFY_USER_AFTER_N_ERRORS_HAVE_OCCURED_TXT,
					LA_UWORD,		&Config -> TransferConfig -> ErrorNotification,
					LA_ID,			GAD_NOTIFY_AFTER_N_ERRORS,
					LA_Chars,		8,
					LAIN_Min,		0,
					LAIN_Max,		65535,
					LAIN_UseIncrementers,	TRUE,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,	VERTICAL_KIND,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,		CYCLE_KIND,
					LA_LabelID,		MSG_NOTIFY_USER_TXT,
					LA_BYTE,		&Config -> TransferConfig -> TransferNotification,
					LA_ID,			GAD_NOTIFY_WHEN,
					LACY_FirstLabel,	MSG_NOTIFY_USER_MODE1_TXT,
					LACY_LastLabel,		MSG_NOTIFY_USER_MODE4_TXT,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	XBAR_KIND,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,	VERTICAL_KIND,
				LA_LabelID,	MSG_V36_0089,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	HORIZONTAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_LabelID,	MSG_LIBPANEL_ASCII_UPLOAD_LIBRARY_GAD,
						LA_STRPTR,	Config -> TransferConfig -> ASCIIUploadLibrary,
						LA_Chars,	20,
						LA_ID,		GAD_ASCII_UPLOAD_LIB,
						GTST_MaxChars,	MAX_FILENAME_LENGTH,
						LAST_Picker,	TRUE,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_LIBPANEL_PREFS_GAD,
						LA_ID,		GAD_ASCII_UPLOAD_PREFS,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_New(Handle,
					LA_Type,	VERTICAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	HORIZONTAL_KIND,
					TAG_DONE);
					{
						LT_New(Handle,
							LA_Type,	CHECKBOX_KIND,
							LA_LabelID,	MSG_LIBPANEL_BUILTIN_ASCII_UPLOAD_GAD,
							LA_BYTE,	&Config -> TransferConfig -> InternalASCIIUpload,
						TAG_DONE);

						LT_New(Handle,
							LA_Type,	BUTTON_KIND,
							LA_LabelID,	MSG_LIBPANEL_PREFS_GAD,
							LA_ID,		GAD_INTERNAL_ASCII_PREFS,
						TAG_DONE);

						LT_EndGroup(Handle);
					}

					LT_New(Handle,
						LA_Type,	VERTICAL_KIND,
					TAG_DONE);
					{
						LT_New(Handle,
							LA_Type,	XBAR_KIND,
						TAG_DONE);

						LT_EndGroup(Handle);
					}

					LT_EndGroup(Handle);
				}

				LT_New(Handle,
					LA_Type,	HORIZONTAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_LabelID,	MSG_LIBPANEL_ASCII_DOWNLOAD_LIBRARY_GAD,
						LA_STRPTR,	Config -> TransferConfig -> ASCIIDownloadLibrary,
						LA_ID,		GAD_ASCII_DOWNLOAD_LIB,
						LA_Chars,	20,
						GTST_MaxChars,	MAX_FILENAME_LENGTH,
						LAST_Picker,	TRUE,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_LIBPANEL_PREFS_GAD,
						LA_ID,		GAD_ASCII_DOWNLOAD_PREFS,
						GA_Disabled,	!Config -> TransferConfig -> ASCIIDownloadLibrary[0],
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_New(Handle,
					LA_Type,	HORIZONTAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	CHECKBOX_KIND,
						LA_LabelID,	MSG_LIBPANEL_BUILTIN_ASCII_DOWNLOAD_GAD,
						LA_BYTE,	&Config -> TransferConfig -> InternalASCIIDownload,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_LIBPANEL_PREFS_GAD,
						LA_ID,		GAD_INTERNAL_ASCII_PREFS,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,	HORIZONTAL_KIND,
				LA_LabelID,	MSG_V36_0090,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	VERTICAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_LabelID,	MSG_LIBPANEL_TEXT_UPLOAD_LIBRARY_GAD,
						LA_STRPTR,	Config -> TransferConfig -> TextUploadLibrary,
						LA_ID,		GAD_TEXT_UPLOAD_LIB,
						GTST_MaxChars,	MAX_FILENAME_LENGTH,
						LAST_Picker,	TRUE,
						LA_Chars,	20,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_LabelID,	MSG_LIBPANEL_TEXT_DOWNLOAD_LIBRARY_GAD,
						LA_STRPTR,	Config -> TransferConfig -> TextDownloadLibrary,
						LA_ID,		GAD_TEXT_DOWNLOAD_LIB,
						GTST_MaxChars,	MAX_FILENAME_LENGTH,
						LAST_Picker,	TRUE,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_New(Handle,
					LA_Type,	VERTICAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_LIBPANEL_PREFS_GAD,
						LA_ID,		GAD_TEXT_UPLOAD_PREFS,
						GA_Disabled,	!Config -> TransferConfig -> TextUploadLibrary[0],
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_LIBPANEL_PREFS_GAD,
						LA_ID,		GAD_TEXT_DOWNLOAD_PREFS,
						GA_Disabled,	!Config -> TransferConfig -> TextDownloadLibrary[0],
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,	HORIZONTAL_KIND,
				LA_LabelID,	MSG_V36_0091,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	VERTICAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_LabelID,	MSG_LIBPANEL_BINARY_UPLOAD_LIBRARY_GAD,
						LA_STRPTR,	Config -> TransferConfig -> BinaryUploadLibrary,
						LA_ID,		GAD_BINARY_UPLOAD_LIB,
						GTST_MaxChars,	MAX_FILENAME_LENGTH,
						LAST_Picker,	TRUE,
						LA_Chars,	20,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_LabelID,	MSG_LIBPANEL_BINARY_DOWNLOAD_LIBRARY_GAD,
						LA_STRPTR,	Config -> TransferConfig -> BinaryDownloadLibrary,
						LA_ID,		GAD_BINARY_DOWNLOAD_LIB,
						GTST_MaxChars,	MAX_FILENAME_LENGTH,
						LAST_Picker,	TRUE,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_New(Handle,
					LA_Type,	VERTICAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_LIBPANEL_PREFS_GAD,
						LA_ID,		GAD_BINARY_UPLOAD_PREFS,
						GA_Disabled,	!Config -> TransferConfig -> BinaryUploadLibrary[0],
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_LIBPANEL_PREFS_GAD,
						LA_ID,		GAD_BINARY_DOWNLOAD_PREFS,
						GA_Disabled,	!Config -> TransferConfig -> BinaryUploadLibrary[0],
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,VERTICAL_KIND,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	XBAR_KIND,
					LAXB_FullSize,	TRUE,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,LA_Type,HORIZONTAL_KIND,
				LAGR_SameSize,	TRUE,
				LAGR_Spread,	TRUE,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_USE_GAD,
					LA_ID,		GAD_USE,
					LABT_ReturnKey,	TRUE,
					LABT_ExtraFat,	TRUE,
				TAG_DONE);

				if(Default)
				{
					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_GLOBAL_DEFAULT_GAD,
						LA_ID,		GAD_DEFAULT,
						LABT_ExtraFat,	TRUE,
					TAG_DONE);
				}

				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_CANCEL_GAD,
					LA_ID,		GAD_CANCEL,
					LABT_EscKey,	TRUE,
					LABT_ExtraFat,	TRUE,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_EndGroup(Handle);
		}

		if(PanelWindow = LT_Layout(Handle,LocaleString(MSG_LIBPANEL_LIBRARY_PREFERENCES_TXT),NULL,0,0,IDCMP_CLOSEWINDOW,0,
			LAWN_HelpHook,		&GuideHook,
			LAWN_Parent,		Window,
			WA_DepthGadget,		TRUE,
			WA_CloseGadget,		TRUE,
			WA_DragBar,		TRUE,
			WA_RMBTrap,		TRUE,
			WA_Activate,		TRUE,
		TAG_DONE))
		{
			struct IntuiMessage	*Message;
			BOOLEAN			 Done = FALSE;
			ULONG			 MsgClass,
						 MsgQualifier;
			UWORD			 MsgCode;
			struct Gadget		*MsgGadget;

			GuideContext(CONTEXT_LIBS);

			PushWindow(PanelWindow);

			LT_ShowWindow(Handle,TRUE);

			do
			{
				if(Wait(PORTMASK(PanelWindow -> UserPort) | SIG_BREAK) & SIG_BREAK)
				{
					SaveConfig(PrivateConfig,Config);

					break;
				}

				while(Message = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort))
				{
					MsgClass	= Message -> Class;
					MsgQualifier	= Message -> Qualifier;
					MsgCode		= Message -> Code;
					MsgGadget	= (struct Gadget *)Message -> IAddress;

					GT_ReplyIMsg(Message);

					LT_HandleInput(Handle,MsgQualifier,&MsgClass,&MsgCode,&MsgGadget);

					if(MsgClass == IDCMP_CLOSEWINDOW)
					{
						SaveConfig(PrivateConfig,Config);

						Done = TRUE;
					}

					if(MsgClass == IDCMP_GADGETUP)
					{
						STRPTR Buffer;

						switch(MsgGadget -> GadgetID)
						{
							case GAD_USE:

								Done = TRUE;
								break;

							case GAD_CANCEL:

								SaveConfig(PrivateConfig,Config);

								Cancel = Done = TRUE;

								OpenIt = FALSE;

								break;

							case GAD_DEFAULT:

								*Default = TRUE;

								Done = TRUE;

								OpenIt = FALSE;

								break;

							case GAD_INTERNAL_ASCII_PREFS:

								LT_LockWindow(PanelWindow);

								ASCIITransferPanel(PanelWindow,Config);

								LT_UnlockWindow(PanelWindow);

								LT_ShowWindow(Handle,TRUE);
								break;

							case GAD_DEFAULT_LIB:
							case GAD_ASCII_UPLOAD_LIB:
							case GAD_ASCII_DOWNLOAD_LIB:
							case GAD_TEXT_UPLOAD_LIB:
							case GAD_TEXT_DOWNLOAD_LIB:
							case GAD_BINARY_UPLOAD_LIB:
							case GAD_BINARY_DOWNLOAD_LIB:

								Buffer = (STRPTR)LT_GetAttributes(Handle,MsgGadget -> GadgetID,TAG_DONE);

								LT_SetAttributes(Handle,MsgGadget -> GadgetID - GAD_DEFAULT_LIB + GAD_DEFAULT_PREFS,GA_Disabled,!Buffer[0],TAG_DONE);

								break;

							case GAD_DEFAULT_PREFS:
							case GAD_ASCII_UPLOAD_PREFS:
							case GAD_ASCII_DOWNLOAD_PREFS:
							case GAD_TEXT_UPLOAD_PREFS:
							case GAD_TEXT_DOWNLOAD_PREFS:
							case GAD_BINARY_UPLOAD_PREFS:
							case GAD_BINARY_DOWNLOAD_PREFS:

								LT_LockWindow(PanelWindow);

								Buffer = (STRPTR)LT_GetAttributes(Handle,MsgGadget -> GadgetID - GAD_DEFAULT_PREFS + GAD_DEFAULT_LIB,TAG_DONE);

								if(Buffer[0])
								{
									if(ChangeProtocol(Buffer))
									{
										if(XProtocolBase)
										{
											XprIO -> xpr_filename = NULL;

											XPRCommandSelected = FALSE;

											ClearSerial();

											NewOptions = FALSE;

											TransferBits = XProtocolSetup(XprIO);

											RestartSerial(FALSE);

											DeleteTransferPanel(TRUE);

												/* Successful? */

											if(!XPRCommandSelected)
											{
												if(!(TransferBits & XPRS_SUCCESS))
												{
													MyEasyRequest(PanelWindow,LocaleString(MSG_GLOBAL_FAILED_TO_SET_UP_PROTOCOL_TXT),LocaleString(MSG_GLOBAL_CONTINUE_TXT),LastXprLibrary);

													CloseLibrary(XProtocolBase);

													XProtocolBase = NULL;

													LastXprLibrary[0] = 0;

													TransferBits = 0;

													SetTransferMenu(FALSE);
												}
												else
													SaveProtocolOpts();
											}
										}
									}

									ResetProtocol();
								}

								LT_UnlockWindow(PanelWindow);

								break;
						}
					}

					if(MsgClass == IDCMP_IDCMPUPDATE && (MsgGadget -> GadgetID >= GAD_DEFAULT_LIB && MsgGadget -> GadgetID <= GAD_BINARY_DOWNLOAD_LIB))
					{
						LT_LockWindow(PanelWindow);

						strcpy(SharedBuffer,(STRPTR)LT_GetAttributes(Handle,MsgGadget -> GadgetID,TAG_DONE));

						if(PickFile(PanelWindow,"Libs:","xpr#?.library",LocaleString(MSG_LIBPANEL_SELECT_DEFAULT_TRANSFER_LIBRARY_TXT + MsgGadget -> GadgetID - GAD_DEFAULT_LIB),SharedBuffer,NT_LIBRARY))
						{
							if(Stricmp(SharedBuffer,(STRPTR)LT_GetAttributes(Handle,MsgGadget -> GadgetID,TAG_DONE)))
							{
								LT_SetAttributes(Handle,MsgGadget -> GadgetID,GTST_String,SharedBuffer,TAG_DONE);

								LT_SetAttributes(Handle,MsgGadget -> GadgetID - GAD_DEFAULT_LIB + GAD_DEFAULT_PREFS,GA_Disabled,!SharedBuffer[0],TAG_DONE);
							}
						}

						LT_UnlockWindow(PanelWindow);

						LT_ShowWindow(Handle,TRUE);
					}
				}
			}
			while(!Done);

			PopWindow();
		}

		LT_DeleteHandle(Handle);
	}

	if(Default)
		return((BYTE)(!Cancel));
	else
	{
		if(XProtocolBase)
			return((BYTE)memcmp(PrivateConfig -> TransferConfig,Config -> TransferConfig,sizeof(struct TransferSettings)));
		else
		{
			if(Config -> TransferConfig -> DefaultLibrary[0])
				return(OpenIt);
			else
				return(FALSE);
		}
	}
}
