/*
**	MiscPanel.c
**
**	Editing panel for miscellaneous parts of the configuration
**
**	Copyright  1990-1994 by Olaf `Olsen' Barthel
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_USE=1000,GAD_CANCEL,GAD_DEFAULT };

STATIC LONG __saveds
ShowSize(struct Gadget *SomeGadget,WORD Level)
{
	return(1L << Level);
}

BYTE __regargs
MiscPanel(struct Configuration *Config,BYTE *Default)
{
	struct LayoutHandle	*Handle;
	BYTE			 Cancel = FALSE;

	SaveConfig(Config,PrivateConfig);

	if(Handle = LT_CreateHandleTags(Window -> WScreen,
		LH_LocaleHook,	&LocaleHook,
	TAG_DONE))
	{
		struct Window	*PanelWindow;
		WORD		 i,BufferSize;

		for(i = 0 ; i < 32 ; i++)
		{
			if((1L << i) == Config -> MiscConfig -> IOBufferSize)
			{
				BufferSize = i;

				break;
			}
		}

		LT_New(Handle,
			LA_Type,	VERTICAL_KIND,
		TAG_DONE);
		{
			LT_New(Handle,
				LA_Type,	VERTICAL_KIND,
				LA_LabelID,	MSG_V36_0107,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	HORIZONTAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	VERTICAL_KIND,
					TAG_DONE);
					{
						LT_New(Handle,
							LA_Type,	CHECKBOX_KIND,
							LA_LabelID,	MSG_MISCPANEL_BACKUP_CONFIGURATION_GAD,
							LA_BYTE,	&Config -> MiscConfig -> BackupConfig,
						TAG_DONE);

						LT_New(Handle,
							LA_Type,	CHECKBOX_KIND,
							LA_LabelID,	MSG_MISCPANEL_SHOW_FAST_MACROS_GAD,
							LA_BYTE,	&Config -> MiscConfig -> OpenFastMacroPanel,
						TAG_DONE);

						LT_New(Handle,
							LA_Type,	CHECKBOX_KIND,
							LA_LabelID,	MSG_MISCPANEL_RELEASE_SERIAL_DEVICE_GAD,
							LA_BYTE,	&Config -> MiscConfig -> ReleaseDevice,
						TAG_DONE);

						LT_New(Handle,
							LA_Type,	CHECKBOX_KIND,
							LA_LabelID,	MSG_MISCPANEL_OVERRIDE_TRANSFER_PATH_GAD,
							LA_BYTE,	&Config -> MiscConfig -> OverridePath,
						TAG_DONE);

						LT_New(Handle,
							LA_Type,	CHECKBOX_KIND,
							LA_LabelID,	MSG_MISCPANEL_USE_AUTO_UPLOAD_PANEL_GAD,
							LA_BYTE,	&Config -> MiscConfig -> AutoUpload,
						TAG_DONE);

						LT_EndGroup(Handle);
					}

					LT_New(Handle,
						LA_Type,	VERTICAL_KIND,
					TAG_DONE);
					{
						LT_New(Handle,
							LA_Type,	CHECKBOX_KIND,
							LA_LabelID,	MSG_MISCPANEL_SET_ARCHIVED_BIT_GAD,
							LA_BYTE,	&Config -> MiscConfig -> SetArchivedBit,
						TAG_DONE);

						LT_New(Handle,
							LA_Type,	CHECKBOX_KIND,
							LA_LabelID,	MSG_MISCPANEL_TRANSFER_ICONS_GAD,
							LA_BYTE,	&Config -> MiscConfig -> TransferIcons,
						TAG_DONE);

						LT_New(Handle,
							LA_Type,	CHECKBOX_KIND,
							LA_LabelID,	MSG_MISCPANEL_TRANSFER_METER_GAD,
							LA_BYTE,	&Config -> MiscConfig -> PerfMeter,
						TAG_DONE);

						LT_New(Handle,
							LA_Type,	CHECKBOX_KIND,
							LA_LabelID,	MSG_MISCPANEL_CREATE_ICONS_GAD,
							LA_BYTE,	&Config -> MiscConfig -> CreateIcons,
						TAG_DONE);

						LT_New(Handle,
							LA_Type,	CHECKBOX_KIND,
							LA_LabelID,	MSG_MISCPANEL_SIMPLE_IO_GAD,
							LA_BYTE,	&Config -> MiscConfig -> SimpleIO,
						TAG_DONE);

						LT_EndGroup(Handle);
					}

					LT_EndGroup(Handle);
				}

				LT_New(Handle,
					LA_Type,	VERTICAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	CHECKBOX_KIND,
						LA_LabelID,	MSG_MISCPANEL_HIDE_UPLOAD_ICON_GAD,
						LA_BYTE,	&Config -> MiscConfig -> HideUploadIcon,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,	VERTICAL_KIND,
				LA_LabelID,	MSG_V36_0108,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,		SliderType,
					LA_LabelID,		MSG_MISCPANEL_PROGRAM_PRIORITY_GAD,
					GTSL_Min,		-128,
					GTSL_Max,		 127,
					GTSL_LevelFormat,	"%4ld",
					LA_BYTE,		&Config -> MiscConfig -> Priority,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,		CYCLE_KIND,
					LA_LabelID,		MSG_MISCPANEL_IDENTIFY_FILES_GAD,
					LACY_FirstLabel,	MSG_MISCPANEL_IDENTIFY_IGNORE_TXT,
					LACY_LastLabel,		MSG_MISCPANEL_IDENTIFY_SOURCE_TXT,
					LA_BYTE,		&Config -> MiscConfig -> IdentifyFiles,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,		SliderType,
					LA_LabelID,		MSG_V36_1810,
					LA_WORD,		&BufferSize,
					GTSL_Min,		12,
					GTSL_Max,		20,
					GTSL_DispFunc,		ShowSize,
					GTSL_LevelFormat,	LocaleBase ? "%7lD" : "%7ld",
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,VERTICAL_KIND,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	XBAR_KIND,
					LAXB_FullSize,	TRUE,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,LA_Type,HORIZONTAL_KIND,
				LAGR_SameSize,	TRUE,
				LAGR_Spread,	TRUE,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_USE_GAD,
					LA_ID,		GAD_USE,
					LABT_ReturnKey,	TRUE,
					LABT_ExtraFat,	TRUE,
				TAG_DONE);

				if(Default)
				{
					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_GLOBAL_DEFAULT_GAD,
						LA_ID,		GAD_DEFAULT,
						LABT_ExtraFat,	TRUE,
					TAG_DONE);
				}

				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_CANCEL_GAD,
					LA_ID,		GAD_CANCEL,
					LABT_EscKey,	TRUE,
					LABT_ExtraFat,	TRUE,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_EndGroup(Handle);
		}

		if(PanelWindow = LT_Layout(Handle,LocaleString(MSG_MISCPANEL_MISCELLANEOUS_PREFERENCES_TXT),NULL,0,0,IDCMP_CLOSEWINDOW,0,
			LAWN_HelpHook,		&GuideHook,
			LAWN_Parent,		Window,
			WA_DepthGadget,		TRUE,
			WA_CloseGadget,		TRUE,
			WA_DragBar,		TRUE,
			WA_RMBTrap,		TRUE,
			WA_Activate,		TRUE,
		TAG_DONE))
		{
			struct IntuiMessage	*Message;
			BOOLEAN			 Done = FALSE;
			ULONG			 MsgClass,
						 MsgQualifier;
			UWORD			 MsgCode;
			struct Gadget		*MsgGadget;

			GuideContext(CONTEXT_MISC);

			PushWindow(PanelWindow);

			LT_ShowWindow(Handle,TRUE);

			do
			{
				if(Wait(PORTMASK(PanelWindow -> UserPort) | SIG_BREAK) & SIG_BREAK)
				{
					SaveConfig(PrivateConfig,Config);

					break;
				}

				while(Message = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort))
				{
					MsgClass	= Message -> Class;
					MsgQualifier	= Message -> Qualifier;
					MsgCode		= Message -> Code;
					MsgGadget	= (struct Gadget *)Message -> IAddress;

					GT_ReplyIMsg(Message);

					LT_HandleInput(Handle,MsgQualifier,&MsgClass,&MsgCode,&MsgGadget);

					if(MsgClass == IDCMP_CLOSEWINDOW)
					{
						SaveConfig(PrivateConfig,Config);

						Done = TRUE;
					}

					if(MsgClass == IDCMP_GADGETUP)
					{
						switch(MsgGadget -> GadgetID)
						{
							case GAD_USE:

								Config -> MiscConfig -> IOBufferSize = 1L << BufferSize;

								Done = TRUE;
								break;

							case GAD_CANCEL:

								SaveConfig(PrivateConfig,Config);

								Cancel = Done = TRUE;
								break;

							case GAD_DEFAULT:

								*Default = TRUE;

								Done = TRUE;
								break;
						}
					}
				}
			}
			while(!Done);

			PopWindow();
		}

		LT_DeleteHandle(Handle);
	}

	if(Default)
		return((BYTE)(!Cancel));
	else
		return((BYTE)memcmp(PrivateConfig -> MiscConfig,Config -> MiscConfig,sizeof(struct MiscSettings)));
}
