/*
**	PathPanel.c
**
**	Editing panel for path configuration
**
**	Copyright  1990-1994 by Olaf `Olsen' Barthel
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_AUPLOAD=1,GAD_ADOWNLOAD,GAD_TUPLOAD,GAD_TDOWNLOAD,
		GAD_BUPLOAD,GAD_BDOWNLOAD,GAD_CONFIGSTORE,GAD_EDITOR,GAD_HELPFILE,

		GAD_USE,GAD_CANCEL,GAD_DEFAULT };

BYTE __regargs
PathPanel(struct Configuration *Config,BYTE *Default)
{
	struct LayoutHandle	*Handle;
	BYTE			 Cancel = FALSE;

	SaveConfig(Config,PrivateConfig);

	if(Handle = LT_CreateHandleTags(Window -> WScreen,
		LH_LocaleHook,	&LocaleHook,
	TAG_DONE))
	{
		struct Window *PanelWindow;

		LT_New(Handle,
			LA_Type,	VERTICAL_KIND,
		TAG_DONE);
		{
			LT_New(Handle,
				LA_Type,	VERTICAL_KIND,
				LA_LabelID,	MSG_V36_0121,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	STRING_KIND,
					LA_LabelID,	MSG_PATHPANEL_DEFAULT_ASCII_UPLOAD_PATH_GAD,
					LA_ID,		GAD_AUPLOAD,
					LA_Chars,	20,
					LAST_Picker,	TRUE,
					GTST_MaxChars,	MAX_FILENAME_LENGTH - 1,
					LA_STRPTR,	Config -> PathConfig -> ASCIIUploadPath,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	STRING_KIND,
					LA_ID,		GAD_ADOWNLOAD,
					LA_LabelID,	MSG_PATHPANEL_DEFAULT_ASCII_DOWNLOAD_PATH_GAD,
					LAST_Picker,	TRUE,
					GTST_MaxChars,	MAX_FILENAME_LENGTH - 1,
					LA_STRPTR,	Config -> PathConfig -> ASCIIDownloadPath,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,		VERTICAL_KIND,
				LA_LabelID,		MSG_V36_0122,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	STRING_KIND,
					LA_LabelID,	MSG_PATHPANEL_DEFAULT_TEXT_UPLOAD_PATH_GAD,
					LA_ID,		GAD_TUPLOAD,
					LA_Chars,	20,
					LAST_Picker,	TRUE,
					GTST_MaxChars,	MAX_FILENAME_LENGTH - 1,
					LA_STRPTR,	Config -> PathConfig -> TextUploadPath,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	STRING_KIND,
					LA_ID,		GAD_TDOWNLOAD,
					LA_LabelID,	MSG_PATHPANEL_DEFAULT_TEXT_DOWNLOAD_PATH_GAD,
					LAST_Picker,	TRUE,
					GTST_MaxChars,	MAX_FILENAME_LENGTH - 1,
					LA_STRPTR,	Config -> PathConfig -> TextDownloadPath,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,		VERTICAL_KIND,
				LA_LabelID,		MSG_V36_0123,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	STRING_KIND,
					LA_LabelID,	MSG_PATHPANEL_DEFAULT_BINARY_UPLOAD_PATH_GAD,
					LA_ID,		GAD_BUPLOAD,
					LA_Chars,	20,
					LAST_Picker,	TRUE,
					GTST_MaxChars,	MAX_FILENAME_LENGTH - 1,
					LA_STRPTR,	Config -> PathConfig -> BinaryUploadPath,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	STRING_KIND,
					LA_ID,		GAD_BDOWNLOAD,
					LA_LabelID,	MSG_PATHPANEL_DEFAULT_BINARY_DOWNLOAD_PATH_GAD,
					LAST_Picker,	TRUE,
					GTST_MaxChars,	MAX_FILENAME_LENGTH - 1,
					LA_STRPTR,	Config -> PathConfig -> BinaryDownloadPath,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,		VERTICAL_KIND,
				LA_LabelID,		MSG_V36_0124,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	STRING_KIND,
					LA_LabelID,	MSG_PATHPANEL_CONFIGURATION_STORAGE_DIR_GAD,
					LA_ID,		GAD_CONFIGSTORE,
					LA_Chars,	20,
					LAST_Picker,	TRUE,
					GTST_MaxChars,	MAX_FILENAME_LENGTH - 1,
					LA_STRPTR,	Config -> PathConfig -> DefaultStorage,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	STRING_KIND,
					LA_ID,		GAD_EDITOR,
					LA_LabelID,	MSG_PATHPANEL_DEFAULT_TEXT_EDITOR_GAD,
					LAST_Picker,	TRUE,
					GTST_MaxChars,	MAX_FILENAME_LENGTH - 1,
					LA_STRPTR,	Config -> PathConfig -> Editor,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	STRING_KIND,
					LA_ID,		GAD_HELPFILE,
					LA_LabelID,	MSG_PATHPANEL_HELP_TEXT_FILE_GAD,
					LAST_Picker,	TRUE,
					GTST_MaxChars,	MAX_FILENAME_LENGTH - 1,
					LA_STRPTR,	Config -> PathConfig -> HelpFile,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,VERTICAL_KIND,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	XBAR_KIND,
					LAXB_FullSize,	TRUE,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,LA_Type,HORIZONTAL_KIND,
				LAGR_SameSize,	TRUE,
				LAGR_Spread,	TRUE,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_USE_GAD,
					LA_ID,		GAD_USE,
					LABT_ReturnKey,	TRUE,
					LABT_ExtraFat,	TRUE,
				TAG_DONE);

				if(Default)
				{
					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_GLOBAL_DEFAULT_GAD,
						LA_ID,		GAD_DEFAULT,
						LABT_ExtraFat,	TRUE,
					TAG_DONE);
				}

				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_CANCEL_GAD,
					LA_ID,		GAD_CANCEL,
					LABT_EscKey,	TRUE,
					LABT_ExtraFat,	TRUE,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_EndGroup(Handle);
		}

		if(PanelWindow = LT_Layout(Handle,LocaleString(MSG_PATHPANEL_PATH_PREFERENCES_TXT),NULL,0,0,IDCMP_CLOSEWINDOW,0,
			LAWN_HelpHook,		&GuideHook,
			LAWN_Parent,		Window,
			WA_DepthGadget,		TRUE,
			WA_CloseGadget,		TRUE,
			WA_DragBar,		TRUE,
			WA_RMBTrap,		TRUE,
			WA_Activate,		TRUE,
		TAG_DONE))
		{
			struct IntuiMessage	*Message;
			BOOLEAN			 Done = FALSE;
			ULONG			 MsgClass,
						 MsgQualifier;
			UWORD			 MsgCode;
			struct Gadget		*MsgGadget;

			GuideContext(CONTEXT_PATHS);

			PushWindow(PanelWindow);

			LT_ShowWindow(Handle,TRUE);

			do
			{
				if(Wait(PORTMASK(PanelWindow -> UserPort) | SIG_BREAK) & SIG_BREAK)
				{
					SaveConfig(PrivateConfig,Config);

					break;
				}

				while(Message = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort))
				{
					MsgClass	= Message -> Class;
					MsgQualifier	= Message -> Qualifier;
					MsgCode		= Message -> Code;
					MsgGadget	= (struct Gadget *)Message -> IAddress;

					GT_ReplyIMsg(Message);

					LT_HandleInput(Handle,MsgQualifier,&MsgClass,&MsgCode,&MsgGadget);

					if(MsgClass == IDCMP_CLOSEWINDOW)
					{
						SaveConfig(PrivateConfig,Config);

						Done = TRUE;
					}

					if(MsgClass == IDCMP_GADGETUP)
					{
						switch(MsgGadget -> GadgetID)
						{
							case GAD_USE:

								Done = TRUE;
								break;

							case GAD_CANCEL:

								SaveConfig(PrivateConfig,Config);

								Cancel = Done = TRUE;
								break;

							case GAD_DEFAULT:

								*Default = TRUE;

								Done = TRUE;
								break;
						}
					}

					if(MsgClass == IDCMP_IDCMPUPDATE)
					{
						if(MsgGadget -> GadgetID >= GAD_AUPLOAD && MsgGadget -> GadgetID <= GAD_HELPFILE)
						{
							if(TypeOfMem((APTR)LT_GetAttributes(Handle,MsgGadget -> GadgetID,TAG_DONE)))
							{
								UBYTE			 DummyBuffer[MAX_FILENAME_LENGTH],
											*DummyChar;
								struct FileRequester	*FileRequest;

								LT_LockWindow(PanelWindow);

								strcpy(DummyBuffer,(STRPTR)LT_GetAttributes(Handle,MsgGadget -> GadgetID,TAG_DONE));

								if(MsgGadget -> GadgetID < GAD_EDITOR || !DummyBuffer[0])
									DummyChar = "";
								else
								{
									if(FilePart(DummyBuffer) == DummyBuffer)
										DummyBuffer[0] = 0;
									else
									{
										DummyChar = PathPart(DummyBuffer);

										*DummyChar = 0;
									}

									DummyChar = FilePart((STRPTR)LT_GetAttributes(Handle,MsgGadget -> GadgetID,TAG_DONE));
								}

								if(FileRequest = GetFile(PanelWindow,LocaleString(MsgGadget -> GadgetID - GAD_AUPLOAD + MSG_PATHPANEL_SELECT_DEFAULT_ASCII_UPLOAD_PATH_TXT),DummyBuffer,DummyChar,DummyBuffer,NULL,FALSE,FALSE,MsgGadget -> GadgetID < GAD_EDITOR,LocaleString(MSG_GLOBAL_SELECT_TXT),TRUE))
								{
									LT_SetAttributes(Handle,MsgGadget -> GadgetID,GTST_String,DummyBuffer,TAG_DONE);

									FreeAslRequest(FileRequest);
								}

								LT_UnlockWindow(PanelWindow);
							}
						}
					}
				}
			}
			while(!Done);

			PopWindow();
		}

		LT_DeleteHandle(Handle);
	}

	if(Default)
		return((BYTE)(!Cancel));
	else
		return((BYTE)memcmp(PrivateConfig -> PathConfig,Config -> PathConfig,sizeof(struct PathSettings)));
}
