/*
**	PreInclude.c
**
**	Definition file for precompiled header file
**
**	Copyright  1990-1994 by Olaf `Olsen' Barthel
**		All Rights Reserved
*/

	/* System includes (just a few). */

#include <intuition/intuitionbase.h>
#include <datatypes/pictureclass.h>
#include <libraries/commodities.h>
#include <intuition/gadgetclass.h>
#include <datatypes/soundclass.h>
#include <libraries/translator.h>
#include <libraries/amigaguide.h>
#include <intuition/imageclass.h>
#include <workbench/workbench.h>
#include <libraries/gadtools.h>
#include <libraries/iffparse.h>
#include <devices/inputevent.h>
#include <graphics/gfxmacros.h>
#include <devices/clipboard.h>
#include <intuition/sghooks.h>
#include <intuition/cghooks.h>
#include <intuition/classes.h>
#include <intuition/icclass.h>
#include <libraries/locale.h>
#include <devices/narrator.h>
#include <graphics/gfxbase.h>
#include <hardware/intbits.h>
#include <hardware/dmabits.h>
#include <hardware/custom.h>
#include <graphics/rpattr.h>
#include <devices/console.h>
#include <devices/conunit.h>
#include <dos/filehandler.h>
#include <devices/serial.h>
#include <graphics/scale.h>
#include <dos/dosextens.h>
#include <libraries/asl.h>
#include <devices/audio.h>
#include <devices/input.h>
#include <devices/timer.h>
#include <exec/execbase.h>
#include <hardware/blit.h>
#include <prefs/prefhdr.h>
#include <prefs/serial.h>
#include <hardware/cia.h>
#include <utility/date.h>
#include <exec/devices.h>
#include <dos/datetime.h>
#include <dos/doshunks.h>
#include <clib/macros.h>
#include <exec/memory.h>
#include <exec/errors.h>
#include <rexx/rxslib.h>
#include <rexx/errors.h>
#include <dos/dostags.h>
#include <dos/rdargs.h>
#include <dos/dosasl.h>
#include <dos/var.h>

	/* Function prototypes. */

#include <clib/commodities_protos.h>
#include <clib/translator_protos.h>
#include <clib/rexxsyslib_protos.h>
#include <clib/amigaguide_protos.h>
#include <clib/intuition_protos.h>
#include <clib/datatypes_protos.h>
#include <clib/graphics_protos.h>
#include <clib/gadtools_protos.h>
#include <clib/iffparse_protos.h>
#include <clib/diskfont_protos.h>
#include <clib/console_protos.h>
#include <clib/utility_protos.h>
#include <clib/layers_protos.h>
#include <clib/locale_protos.h>
#include <clib/timer_protos.h>
#include <clib/alib_protos.h>
#include <clib/icon_protos.h>
#include <clib/exec_protos.h>
#include <clib/dos_protos.h>
#include <clib/asl_protos.h>
#include <clib/wb_protos.h>

	/* Include the following direct library interface definitions. */

#ifndef DEBUG
#include <pragmas/console_pragmas.h>
#include <pragmas/utility_pragmas.h>
#include <pragmas/layers_pragmas.h>
#include <pragmas/timer_pragmas.h>
#include <pragmas/exec_pragmas.h>
#endif	/* DEBUG */

	/* Standard `C' includes. */

#include <string.h>
#include <stdarg.h>
#include <stdlib.h>
#include <stddef.h>

	/* Include string IDs. */

#include "termStrings.h"

	/* Include the `term' extra definitions. */

#include "termExtras.h"

	/* Include the OwnDevUnit definitions. */

#include "OwnDevUnit.h"

	/* Include the XPR definitions. */

#include "xproto.h"

	/* Include the XEM definitions. */

#include "xem.h"

	/* Include the rendezvous interface definitions. */

#include "Rendezvous.h"

	/* If desired, include the global definitions and prototypes as well. */

#ifdef INCLUDEALL
#include "termGlobal.h"
#include "termARexxAttributes.h"
#include "termARexxGlobal.h"
#endif	/* INCLUDEALL */

	/* The user interface definitions. */

#include "gtlayout.h"

	/* DNet/ParaBIT support. */

/*#include "dnet/dnet.h"*/
/*#include "lib/dnetlib.h"*/

/*#define PORT_TERM 	0002*/
/*#define PORT_SHELL 	0005*/
/*#define PORT_JUMPSTART	8207*/
/*#define PORT_DOWNLOAD 	8200*/
/*#define PORT_UPLOAD 	8205*/
