/*
**	termARexxAttributes.h
**
**	Names and codes for ARexx attribute names
**
**	Copyright  1990-1994 by Olaf `Olsen' Barthel
**		All Rights Reserved
*/

enum	{	ATTR_APPLICATION,
		ATTR_APPLICATION_VERSION,
		ATTR_APPLICATION_SCREEN,
		ATTR_APPLICATION_SESSION,
		ATTR_APPLICATION_SESSION_ONLINE,
		ATTR_APPLICATION_SESSION_SESSIONSTART,
		ATTR_APPLICATION_SESSION_BYTESSENT,
		ATTR_APPLICATION_SESSION_BYTESRECEIVED,
		ATTR_APPLICATION_SESSION_CONNECTMESSAGE,
		ATTR_APPLICATION_SESSION_BBSNAME,
		ATTR_APPLICATION_SESSION_BBSNUMBER,
		ATTR_APPLICATION_SESSION_BBSCOMMENT,
		ATTR_APPLICATION_SESSION_USERNAME,
		ATTR_APPLICATION_SESSION_ONLINEMINUTES,
		ATTR_APPLICATION_SESSION_ONLINECOST,
		ATTR_APPLICATION_AREXX,
		ATTR_APPLICATION_LASTERROR,
		ATTR_APPLICATION_TERMINAL,
		ATTR_APPLICATION_TERMINAL_ROWS,
		ATTR_APPLICATION_TERMINAL_COLUMNS,
		ATTR_APPLICATION_BUFFER,
		ATTR_APPLICATION_BUFFER_SIZE,
		ATTR_PHONEBOOK,
		ATTR_PHONEBOOK_COUNT,
		ATTR_PHONEBOOK_X,
		ATTR_PHONEBOOK_X_NAME,
		ATTR_PHONEBOOK_X_NUMBER,
		ATTR_PHONEBOOK_X_COMMENTTEXT,
		ATTR_PHONEBOOK_X_USERNAME,
		ATTR_PHONEBOOK_X_PASSWORDTEXT,
		ATTR_PREFS_SERIAL,
		ATTR_PREFS_SERIAL_BAUDRATE,
		ATTR_PREFS_SERIAL_BREAKLENGTH,
		ATTR_PREFS_SERIAL_BUFFERSIZE,
		ATTR_PREFS_SERIAL_DEVICENAME,
		ATTR_PREFS_SERIAL_UNIT,
		ATTR_PREFS_SERIAL_BITSPERCHAR,
		ATTR_PREFS_SERIAL_PARITYMODE,
		ATTR_PREFS_SERIAL_STOPBITS,
		ATTR_PREFS_SERIAL_HANDSHAKINGMODE,
		ATTR_PREFS_SERIAL_DUPLEXMODE,
		ATTR_PREFS_SERIAL_XONXOFF,
		ATTR_PREFS_SERIAL_HIGHSPEED,
		ATTR_PREFS_SERIAL_SHARED,
		ATTR_PREFS_SERIAL_STRIPBIT8,
		ATTR_PREFS_SERIAL_CARRIERCHECK,
		ATTR_PREFS_SERIAL_PASSXONXOFFTHROUGH,
		ATTR_PREFS_SERIAL_QUANTUM,
		ATTR_PREFS_SERIAL_USE_OWNDEVUNIT,
		ATTR_PREFS_SERIAL_OWNDEVUNIT_REQUEST,
		ATTR_PREFS_MODEM,
		ATTR_PREFS_MODEM_MODEMINITTEXT,
		ATTR_PREFS_MODEM_MODEMEXITTEXT,
		ATTR_PREFS_MODEM_MODEMHANGUPTEXT,
		ATTR_PREFS_MODEM_DIALPREFIXTEXT,
		ATTR_PREFS_MODEM_DIALSUFFIXTEXT,
		ATTR_PREFS_MODEM_NOCARRIERTEXT,
		ATTR_PREFS_MODEM_NODIALTONETEXT,
		ATTR_PREFS_MODEM_CONNECTTEXT,
		ATTR_PREFS_MODEM_VOICETEXT,
		ATTR_PREFS_MODEM_RINGTEXT,
		ATTR_PREFS_MODEM_BUSYTEXT,
		ATTR_PREFS_MODEM_OKTEXT,
		ATTR_PREFS_MODEM_ERRORTEXT,
		ATTR_PREFS_MODEM_REDIALDELAY,
		ATTR_PREFS_MODEM_DIALRETRIES,
		ATTR_PREFS_MODEM_DIALTIMEOUT,
		ATTR_PREFS_MODEM_CONNECTAUTOBAUD,
		ATTR_PREFS_MODEM_HANGUPDROPSDTR,
		ATTR_PREFS_MODEM_REDIALAFTERHANGUP,
		ATTR_PREFS_MODEM_NOCARRIERISBUSY,
		ATTR_PREFS_MODEM_CONNECTLIMIT,
		ATTR_PREFS_MODEM_CONNECTLIMITMACRO,
		ATTR_PREFS_MODEM_TIME_TO_CONNECT,
		ATTR_PREFS_COMMANDS,
		ATTR_PREFS_COMMANDS_STARTUPMACROTEXT,
		ATTR_PREFS_COMMANDS_LOGOFFMACROTEXT,
		ATTR_PREFS_COMMANDS_UPLOADMACROTEXT,
		ATTR_PREFS_COMMANDS_DOWNLOADMACROTEXT,
		ATTR_PREFS_COMMANDS_LOGINMACROTEXT,
		ATTR_PREFS_SCREEN,
		ATTR_PREFS_SCREEN_WINDOW_BORDER,
		ATTR_PREFS_SCREEN_SPLIT_STATUS,
		ATTR_PREFS_SCREEN_COLOURMODE,
		ATTR_PREFS_SCREEN_FONTNAME,
		ATTR_PREFS_SCREEN_FONTSIZE,
		ATTR_PREFS_SCREEN_MAKESCREENPUBLIC,
		ATTR_PREFS_SCREEN_SHANGHAIWINDOWS,
		ATTR_PREFS_SCREEN_BLINKING,
		ATTR_PREFS_SCREEN_FASTERLAYOUT,
		ATTR_PREFS_SCREEN_TITLEBAR,
		ATTR_PREFS_SCREEN_STATUSLINEMODE,
		ATTR_PREFS_SCREEN_USEWORKBENCH,
		ATTR_PREFS_SCREEN_PUBSCREENNAME,
		ATTR_PREFS_SCREEN_ONLINEDISPLAY,
		ATTR_PREFS_SCREEN_USEPENS,
		ATTR_PREFS_TERMINAL,
		ATTR_PREFS_TERMINAL_BELLMODE,
		ATTR_PREFS_TERMINAL_ALERTMODE,
		ATTR_PREFS_TERMINAL_EMULATIONMODE,
		ATTR_PREFS_TERMINAL_FONTMODE,
		ATTR_PREFS_TERMINAL_SENDCRMODE,
		ATTR_PREFS_TERMINAL_SENDLFMODE,
		ATTR_PREFS_TERMINAL_RECEIVECRMODE,
		ATTR_PREFS_TERMINAL_RECEIVELFMODE,
		ATTR_PREFS_TERMINAL_NUMCOLUMNS,
		ATTR_PREFS_TERMINAL_NUMLINES,
		ATTR_PREFS_TERMINAL_KEYMAPNAME,
		ATTR_PREFS_TERMINAL_EMULATIONNAME,
		ATTR_PREFS_TERMINAL_FONTNAME,
		ATTR_PREFS_TERMINAL_FONTSIZE,
		ATTR_PREFS_TERMINAL_USETERMINALPROCESS,
		ATTR_PREFS_PATHS,
		ATTR_PREFS_PATHS_ASCIIUPLOADPATH,
		ATTR_PREFS_PATHS_ASCIIDOWNLOADPATH,
		ATTR_PREFS_PATHS_TEXTUPLOADPATH,
		ATTR_PREFS_PATHS_TEXTDOWNLOADPATH,
		ATTR_PREFS_PATHS_BINARYUPLOADPATH,
		ATTR_PREFS_PATHS_BINARYDOWNLOADPATH,
		ATTR_PREFS_PATHS_CONFIGPATH,
		ATTR_PREFS_PATHS_EDITORNAME,
		ATTR_PREFS_PATHS_HELPFILENAME,
		ATTR_PREFS_MISC,
		ATTR_PREFS_MISC_PRIORITY,
		ATTR_PREFS_MISC_BACKUPCONFIG,
		ATTR_PREFS_MISC_OPENFASTMACROPANEL,
		ATTR_PREFS_MISC_RELEASEDEVICE,
		ATTR_PREFS_MISC_OVERRIDEPATH,
		ATTR_PREFS_MISC_AUTOUPLOAD,
		ATTR_PREFS_MISC_SETARCHIVEDBIT,
		ATTR_PREFS_MISC_COMMENTMODE,
		ATTR_PREFS_MISC_TRANSFERICONS,
		ATTR_PREFS_MISC_CREATEICONS,
		ATTR_PREFS_MISC_SIMPLEIO,
		ATTR_PREFS_MISC_TRANSFER_PERFMETER,
		ATTR_PREFS_MISC_IOBUFFERSIZE,
		ATTR_PREFS_MISC_HIDE_UPLOAD_ICON,
		ATTR_PREFS_CLIPBOARD,
		ATTR_PREFS_CLIPBOARD_UNIT,
		ATTR_PREFS_CLIPBOARD_LINEDELAY,
		ATTR_PREFS_CLIPBOARD_CHARDELAY,
		ATTR_PREFS_CLIPBOARD_INSERTPREFIXTEXT,
		ATTR_PREFS_CLIPBOARD_INSERTSUFFIXTEXT,
		ATTR_PREFS_CLIPBOARD_TEXTPACING,
		ATTR_PREFS_CLIPBOARD_LINEPROMPT,
		ATTR_PREFS_CLIPBOARD_SENDTIMEOUT,
		ATTR_PREFS_CAPTURE,
		ATTR_PREFS_CAPTURE_LOGACTIONS,
		ATTR_PREFS_CAPTURE_LOGCALLS,
		ATTR_PREFS_CAPTURE_LOGFILENAME,
		ATTR_PREFS_CAPTURE_MAXBUFFERSIZE,
		ATTR_PREFS_CAPTURE_BUFFER,
		ATTR_PREFS_CAPTURE_CONNECTAUTOCAPTURE,
		ATTR_PREFS_CAPTURE_AUTOCAPTUREDATE,
		ATTR_PREFS_CAPTURE_CAPTUREFILTER,
		ATTR_PREFS_CAPTURE_CAPTUREPATH,
		ATTR_PREFS_CAPTURE_CALLLOGFILENAME,
		ATTR_PREFS_CAPTURE_BUFFERSAVEPATH,
		ATTR_PREFS_CAPTURE_OPENBUFFERWINDOW,
		ATTR_PREFS_CAPTURE_OPENBUFFERSCREEN,
		ATTR_PREFS_CAPTURE_BUFFERSCREENPOSITION,
		ATTR_PREFS_CAPTURE_BUFFERWIDTH,
		ATTR_PREFS_CAPTURE_REMEMBER_BUFFERWINDOW,
		ATTR_PREFS_CAPTURE_REMEMBER_BUFFERSCREEN,
		ATTR_PREFS_CAPTURE_SEARCH_HISTORY,
		ATTR_PREFS_CAPTURE_CONVERTCHARACTERS,
		ATTR_PREFS_FILE,
		ATTR_PREFS_FILE_TRANSFERPROTOCOLNAME,
		ATTR_PREFS_FILE_TRANSLATIONFILENAME,
		ATTR_PREFS_FILE_MACROFILENAME,
		ATTR_PREFS_FILE_CURSORFILENAME,
		ATTR_PREFS_FILE_FASTMACROFILENAME,
		ATTR_PREFS_EMULATION,
		ATTR_PREFS_EMULATION_CURSORMODE,
		ATTR_PREFS_EMULATION_NUMERICMODE,
		ATTR_PREFS_EMULATION_CURSORWRAP,
		ATTR_PREFS_EMULATION_LINEWRAP,
		ATTR_PREFS_EMULATION_INSERTMODE,
		ATTR_PREFS_EMULATION_NEWLINEMODE,
		ATTR_PREFS_EMULATION_FONTSCALEMODE,
		ATTR_PREFS_EMULATION_SCROLLMODE,
		ATTR_PREFS_EMULATION_DESTRUCTIVEBACKSPACE,
		ATTR_PREFS_EMULATION_SWAPBSDELETE,
		ATTR_PREFS_EMULATION_CURSORLOCKED,
		ATTR_PREFS_EMULATION_FONTLOCKED,
		ATTR_PREFS_EMULATION_NUMPADLOCKED,
		ATTR_PREFS_EMULATION_PRINTERENABLED,
		ATTR_PREFS_EMULATION_ANSWERBACKTEXT,
		ATTR_PREFS_EMULATION_CLS_RESETS_CURSOR,
		ATTR_PREFS_EMULATION_MAXSCROLL,
		ATTR_PREFS_EMULATION_MAXJUMP,
		ATTR_PREFS_EMULATION_WRAPLOCKED,
		ATTR_PREFS_EMULATION_STYLELOCKED,
		ATTR_PREFS_EMULATION_COLOURLOCKED,
		ATTR_PREFS_EMULATION_USEPENS,
		ATTR_PREFS_TRANSFER,
		ATTR_PREFS_TRANSFER_DEFAULT_LIBRARY,
		ATTR_PREFS_TRANSFER_ASCII_UPLOAD_LIBRARY,
		ATTR_PREFS_TRANSFER_INTERNAL_ASCII_UPLOAD,
		ATTR_PREFS_TRANSFER_ASCII_DOWNLOAD_LIBRARY,
		ATTR_PREFS_TRANSFER_INTERNAL_ASCII_DOWNLOAD,
		ATTR_PREFS_TRANSFER_QUIET_TRANSFER,
		ATTR_PREFS_TRANSFER_TEXT_UPLOAD_LIBRARY,
		ATTR_PREFS_TRANSFER_TEXT_DOWNLOAD_LIBRARY,
		ATTR_PREFS_TRANSFER_BINARY_UPLOAD_LIBRARY,
		ATTR_PREFS_TRANSFER_BINARY_DOWNLOAD_LIBRARY,
		ATTR_PREFS_TRANSFER_MANGLE_FILE_NAMES,
		ATTR_PREFS_TRANSFER_LINEDELAY,
		ATTR_PREFS_TRANSFER_CHARDELAY,
		ATTR_PREFS_TRANSFER_TEXTPACING,
		ATTR_PREFS_TRANSFER_LINEPROMPT,
		ATTR_PREFS_TRANSFER_SENDTIMEOUT,
		ATTR_PREFS_TRANSFER_STRIP_BIT_8,
		ATTR_PREFS_TRANSFER_IGNORE_DATA_PAST_ARNOLD,
		ATTR_PREFS_TRANSFER_TERMINATOR_CHAR,
		ATTR_PREFS_TRANSFER_ERROR_NOTIFY_COUNT,
		ATTR_PREFS_TRANSFER_ERROR_NOTIFY_WHEN,
		ATTR_PREFS_SPEECH,
		ATTR_PREFS_SPEECH_RATE,
		ATTR_PREFS_SPEECH_PITCH,
		ATTR_PREFS_SPEECH_FREQUENCY,
		ATTR_PREFS_SPEECH_SEXMODE,
		ATTR_PREFS_SPEECH_VOLUME,
		ATTR_PREFS_SPEECH_SPEECH,
		ATTR_PREFS_TRANSLATIONS,
		ATTR_PREFS_TRANSLATIONS_X,
		ATTR_PREFS_TRANSLATIONS_X_SEND,
		ATTR_PREFS_TRANSLATIONS_X_RECEIVE,
		ATTR_PREFS_FASTMACROS,
		ATTR_PREFS_FASTMACROS_COUNT,
		ATTR_PREFS_FASTMACROS_X,
		ATTR_PREFS_FASTMACROS_X_NAME,
		ATTR_PREFS_FASTMACROS_X_CODE,
		ATTR_PREFS_HOTKEYS,
		ATTR_PREFS_HOTKEYS_TERMSCREENTOFRONTTEXT,
		ATTR_PREFS_HOTKEYS_BUFFERSCREENTOFRONTTEXT,
		ATTR_PREFS_HOTKEYS_SKIPDIALENTRYTEXT,
		ATTR_PREFS_HOTKEYS_ABORTAREXX,
		ATTR_PREFS_HOTKEYS_COMMODITYPRIORITY,
		ATTR_PREFS_HOTKEYS_HOTKEYSENABLED,
		ATTR_PREFS_CURSORKEYS,
		ATTR_PREFS_CURSORKEYS_UPTEXT,
		ATTR_PREFS_CURSORKEYS_RIGHTTEXT,
		ATTR_PREFS_CURSORKEYS_DOWNTEXT,
		ATTR_PREFS_CURSORKEYS_LEFTTEXT,
		ATTR_PREFS_CURSORKEYS_SHIFT,
		ATTR_PREFS_CURSORKEYS_SHIFT_UPTEXT,
		ATTR_PREFS_CURSORKEYS_SHIFT_RIGHTTEXT,
		ATTR_PREFS_CURSORKEYS_SHIFT_DOWNTEXT,
		ATTR_PREFS_CURSORKEYS_SHIFT_LEFTTEXT,
		ATTR_PREFS_CURSORKEYS_ALT,
		ATTR_PREFS_CURSORKEYS_ALT_UPTEXT,
		ATTR_PREFS_CURSORKEYS_ALT_RIGHTTEXT,
		ATTR_PREFS_CURSORKEYS_ALT_DOWNTEXT,
		ATTR_PREFS_CURSORKEYS_ALT_LEFTTEXT,
		ATTR_PREFS_CURSORKEYS_CONTROL,
		ATTR_PREFS_CURSORKEYS_CONTROL_UPTEXT,
		ATTR_PREFS_CURSORKEYS_CONTROL_RIGHTTEXT,
		ATTR_PREFS_CURSORKEYS_CONTROL_DOWNTEXT,
		ATTR_PREFS_CURSORKEYS_CONTROL_LEFTTEXT,
		ATTR_PREFS_FUNCTIONKEYS,
		ATTR_PREFS_FUNCTIONKEYS_X,
		ATTR_PREFS_FUNCTIONKEYS_SHIFT,
		ATTR_PREFS_FUNCTIONKEYS_SHIFT_X,
		ATTR_PREFS_FUNCTIONKEYS_ALT,
		ATTR_PREFS_FUNCTIONKEYS_ALT_X,
		ATTR_PREFS_FUNCTIONKEYS_CONTROL,
		ATTR_PREFS_FUNCTIONKEYS_CONTROL_X,
		ATTR_PREFS_PROTOCOL,
		ATTR_PREFS_CONSOLE,
		ATTR_PREFS_SOUND,
		ATTR_PREFS_SOUND_BELLNAME,
		ATTR_PREFS_SOUND_CONNECTNAME,
		ATTR_PREFS_SOUND_DISCONNECTNAME,
		ATTR_PREFS_SOUND_GOODTRANSFERNAME,
		ATTR_PREFS_SOUND_BADTRANSFERNAME,
		ATTR_PREFS_SOUND_RINGNAME,
		ATTR_PREFS_SOUND_VOICENAME,
		ATTR_PREFS_SOUND_PRELOAD,
		ATTR_PREFS_SOUND_ERROR,
		ATTR_PREFS_SOUND_VOLUME
	};
