/*
**	TrapPanel.c
**
**	Editing panel for trap list
**
**	Copyright  1990-1994 by Olaf `Olsen' Barthel
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_LIST,GAD_SEQUENCE,GAD_COMMAND,
		GAD_TOP,GAD_UP,GAD_DOWN,GAD_END,
		GAD_NEW,GAD_REMOVE,GAD_CLEAR,
		GAD_LOAD,GAD_SAVE,GAD_USE
	};

VOID
TrapPanel()
{
	struct LayoutHandle	*Handle;
	struct GenericList	*TrapList;
	struct TrapNode		*Node,
				*Next;

	ObtainSemaphore(&GenericListTable[GLIST_TRAP] -> ListSemaphore);

	TrapList = GenericListTable[GLIST_TRAP];

	if(Handle = LT_CreateHandleTags(Window -> WScreen,
		LH_LocaleHook,	&LocaleHook,
	TAG_DONE))
	{
		struct Window	*LocalWindow;
		struct IBox	 Bounds;

		LT_New(Handle,
			LA_Type,	VERTICAL_KIND,
		TAG_DONE);
		{
			LT_New(Handle,
				LA_Type,	VERTICAL_KIND,
				LA_LabelID,	MSG_TRAPPANEL_TRAP_CONTROLS_TXT,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	LISTVIEW_KIND,
					LA_LabelID,	MSG_TRAPPANEL_TRAP_LIST_TXT,
					LA_LabelPlace,	PLACE_LEFT,
					LA_Chars,	30,
					LA_Lines,	10,
					LA_ID,		GAD_LIST,
					LALV_CursorKey,	TRUE,
					LALV_MaxGrowY,	20,
					LALV_MaxGrowX,	50,
					GTLV_Labels,	TrapList,

					Kick30 ? LALV_Link : TAG_IGNORE, NIL_LINK,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	STRING_KIND,
					LA_LabelID,	MSG_TRAPPANEL_SEQUENCE_TXT,
					LA_ID,		GAD_SEQUENCE,
					GTST_MaxChars,	255,
					GA_Disabled,	TRUE,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	STRING_KIND,
					LA_LabelID,	MSG_TRAPPANEL_COMMAND_TXT,
					LA_ID,		GAD_COMMAND,
					GTST_MaxChars,	255,
					GA_Disabled,	TRUE,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,	HORIZONTAL_KIND,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	HORIZONTAL_KIND,
					LA_LabelID,	MSG_V36_0038,
					LA_Spread,	TRUE,
					LA_SameSize,	TRUE,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelText,	"|<",
						LA_ID,		GAD_TOP,
						LA_NoKey,	TRUE,
						GA_Disabled,	TRUE,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelText,	"<",
						LA_ID,		GAD_UP,
						LA_NoKey,	TRUE,
						GA_Disabled,	TRUE,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelText,	">",
						LA_ID,		GAD_DOWN,
						LA_NoKey,	TRUE,
						GA_Disabled,	TRUE,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelText,	">|",
						LA_ID,		GAD_END,
						LA_NoKey,	TRUE,
						GA_Disabled,	TRUE,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_New(Handle,
					LA_Type,	HORIZONTAL_KIND,
					LA_LabelID,	MSG_V36_0043,
					LA_Spread,	TRUE,
					LA_SameSize,	TRUE,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_FASTMACROPANEL_NEW_GAD,
						LA_ID,		GAD_NEW,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_GLOBAL_REMOVE_GAD,
						LA_ID,		GAD_REMOVE,
						GA_Disabled,	TRUE,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_UPLOADQUEUE_CLEAR_TXT,
						LA_ID,		GAD_CLEAR,
						GA_Disabled,	TrapList -> ListHeader . mlh_Head -> mln_Succ == NULL,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,	VERTICAL_KIND,
			TAG_DONE);
			{
				LT_New(Handle,LA_Type,XBAR_KIND,LAXB_FullSize,TRUE,TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,LA_Type,HORIZONTAL_KIND,
				LAGR_SameSize,	TRUE,
				LAGR_Spread,	TRUE,
				LA_ExtraSpace,	TRUE,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_USE_GAD,
					LA_ID,		GAD_USE,
					LABT_ReturnKey,	TRUE,
					LABT_ExtraFat,	TRUE,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_LOAD_GAD,
					LA_ID,		GAD_LOAD,
					LABT_ExtraFat,	TRUE,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_SAVE_GAD,
					LA_ID,		GAD_SAVE,
					LABT_ExtraFat,	TRUE,
					GA_Disabled,	TrapList -> ListHeader . mlh_Head -> mln_Succ == NULL,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_EndGroup(Handle);
		}

		if(Screen && Window)
		{
			Bounds . Left	= Window -> LeftEdge;
			Bounds . Top	= Window -> TopEdge;
			Bounds . Width	= Window -> Width;
			Bounds . Height	= Window -> Height;
		}

		if(LocalWindow = LT_Layout(Handle,LocaleString(MSG_TRAPPANEL_TRAP_PREFERENCES_TXT),Screen ? &Bounds : NULL,0,0,IDCMP_CLOSEWINDOW,0,
			LAWN_HelpHook,		&GuideHook,
			LAWN_Parent,		Window,
			WA_DepthGadget,		TRUE,
			WA_CloseGadget,		TRUE,
			WA_DragBar,		TRUE,
			WA_RMBTrap,		TRUE,
			WA_Activate,		TRUE,
		TAG_DONE))
		{
			struct IntuiMessage	*Message;
			BOOLEAN			 Done = FALSE;
			ULONG			 MsgClass,
						 MsgQualifier;
			UWORD			 MsgCode;
			struct Gadget		*MsgGadget;

			struct TrapNode		*Selected = NULL;
			ULONG			 Offset = 0;

			UBYTE		 	 DummyBuffer[MAX_FILENAME_LENGTH],
						*DummyChar;
			struct FileRequester	*FileRequest;

			GuideContext(CONTEXT_TRAPS);

			PushWindow(LocalWindow);

			do
			{
				if(Wait(PORTMASK(LocalWindow -> UserPort) | SIG_BREAK) & SIG_BREAK)
					break;

				while(Message = (struct IntuiMessage *)GT_GetIMsg(LocalWindow -> UserPort))
				{
					MsgClass	= Message -> Class;
					MsgQualifier	= Message -> Qualifier;
					MsgCode		= Message -> Code;
					MsgGadget	= (struct Gadget *)Message -> IAddress;

					GT_ReplyIMsg(Message);

					LT_HandleInput(Handle,MsgQualifier,&MsgClass,&MsgCode,&MsgGadget);

					if(MsgClass == IDCMP_CLOSEWINDOW)
						Done = TRUE;

					if(MsgClass == IDCMP_GADGETUP)
					{
						switch(MsgGadget -> GadgetID)
						{
							case GAD_USE:

								Done = TRUE;
								break;

							case GAD_TOP:

								LT_SetAttributes(Handle,GAD_LIST,
									GTLV_Labels,	~0,
								TAG_DONE);

								Remove((struct Node *)Selected);

								AddHead((struct List *)TrapList,(struct Node *)Selected);

								Offset = 0;

								LT_SetAttributes(Handle,GAD_LIST,
									GTLV_Labels,	TrapList,
									GTLV_Selected,	Offset,
									GTLV_Top,	Offset,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_TOP,
									GA_Disabled,	TRUE,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_UP,
									GA_Disabled,	TRUE,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_DOWN,
									GA_Disabled,	!Selected -> Node . ln_Succ -> ln_Succ,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_END,
									GA_Disabled,	!Selected -> Node . ln_Succ -> ln_Succ,
								TAG_DONE);

								TrapsChanged = TRUE;
								break;

							case GAD_UP:

								LT_SetAttributes(Handle,GAD_LIST,
									GTLV_Labels,	~0,
								TAG_DONE);

								Node = (struct TrapNode *)Selected -> Node . ln_Pred -> ln_Pred;

								Remove((struct Node *)Selected);

								Insert((struct List *)TrapList,(struct Node *)Selected,(struct Node *)Node);

								Offset--;

								LT_SetAttributes(Handle,GAD_LIST,
									GTLV_Labels,	TrapList,
									GTLV_Selected,	Offset,
									GTLV_Top,	Offset,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_TOP,
									GA_Disabled,	!Selected -> Node . ln_Pred -> ln_Pred,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_UP,
									GA_Disabled,	!Selected -> Node . ln_Pred -> ln_Pred,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_DOWN,
									GA_Disabled,	!Selected -> Node . ln_Succ -> ln_Succ,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_END,
									GA_Disabled,	!Selected -> Node . ln_Succ -> ln_Succ,
								TAG_DONE);

								TrapsChanged = TRUE;

								break;

							case GAD_DOWN:

								LT_SetAttributes(Handle,GAD_LIST,
									GTLV_Labels,	~0,
								TAG_DONE);

								Node = (struct TrapNode *)Selected -> Node . ln_Succ;

								Remove((struct Node *)Selected);

								Insert((struct List *)TrapList,(struct Node *)Selected,(struct Node *)Node);

								Offset++;

								LT_SetAttributes(Handle,GAD_LIST,
									GTLV_Labels,	TrapList,
									GTLV_Selected,	Offset,
									GTLV_Top,	Offset,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_TOP,
									GA_Disabled,	!Selected -> Node . ln_Pred -> ln_Pred,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_UP,
									GA_Disabled,	!Selected -> Node . ln_Pred -> ln_Pred,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_DOWN,
									GA_Disabled,	!Selected -> Node . ln_Succ -> ln_Succ,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_END,
									GA_Disabled,	!Selected -> Node . ln_Succ -> ln_Succ,
								TAG_DONE);

								TrapsChanged = TRUE;

								break;

							case GAD_END:

								LT_SetAttributes(Handle,GAD_LIST,
									GTLV_Labels,	~0,
								TAG_DONE);

								Remove((struct Node *)Selected);

								AddTail((struct List *)TrapList,(struct Node *)Selected);

								Offset = TrapList -> ListCount - 1;

								LT_SetAttributes(Handle,GAD_LIST,
									GTLV_Labels,	TrapList,
									GTLV_Selected,	Offset,
									GTLV_Top,	Offset,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_TOP,
									GA_Disabled,	!Selected -> Node . ln_Pred -> ln_Pred,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_UP,
									GA_Disabled,	!Selected -> Node . ln_Pred -> ln_Pred,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_DOWN,
									GA_Disabled,	!Selected -> Node . ln_Succ -> ln_Succ,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_END,
									GA_Disabled,	!Selected -> Node . ln_Succ -> ln_Succ,
								TAG_DONE);

								TrapsChanged = TRUE;

								break;

							case GAD_NEW:

								if(Node = CreateTrapNode("",""))
								{
									LT_SetAttributes(Handle,GAD_LIST,
										GTLV_Labels,	~0,
									TAG_DONE);

									AddTail((struct List *)TrapList,(struct Node *)Node);

									LT_SetAttributes(Handle,GAD_LIST,
										GTLV_Labels,	TrapList,
										GTLV_Selected,	TrapList -> ListCount++,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_COMMAND,
										GTST_String,	"",
										GA_Disabled,	FALSE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_SEQUENCE,
										GTST_String,	"",
										GA_Disabled,	FALSE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_REMOVE,
										GA_Disabled,	FALSE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_SAVE,
										GA_Disabled,	FALSE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_CLEAR,
										GA_Disabled,	FALSE,
									TAG_DONE);

									Selected = Node;

									Offset = MsgCode;

									LT_SetAttributes(Handle,GAD_TOP,
										GA_Disabled,	!Selected -> Node . ln_Pred -> ln_Pred,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_UP,
										GA_Disabled,	!Selected -> Node . ln_Pred -> ln_Pred,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_DOWN,
										GA_Disabled,	!Selected -> Node . ln_Succ -> ln_Succ,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_END,
										GA_Disabled,	!Selected -> Node . ln_Succ -> ln_Succ,
									TAG_DONE);

									LT_Activate(Handle,GAD_SEQUENCE);

									TrapsChanged = TRUE;
								}
								else
									DisplayBeep(LocalWindow -> WScreen);

								break;

							case GAD_CLEAR:

								LT_SetAttributes(Handle,GAD_LIST,
									GTLV_Labels,	~0,
								TAG_DONE);

								FreeList((struct List *)TrapList);

								TrapList -> ListCount = 0;

								LT_SetAttributes(Handle,GAD_LIST,
									GTLV_Labels,	TrapList,
									GTLV_Selected,	~0,
								TAG_DONE);

								Selected = NULL;

								LT_SetAttributes(Handle,GAD_TOP,
									GA_Disabled,	TRUE,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_UP,
									GA_Disabled,	TRUE,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_DOWN,
									GA_Disabled,	TRUE,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_END,
									GA_Disabled,	TRUE,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_REMOVE,
									GA_Disabled,	TRUE,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_SEQUENCE,
									GTST_String,	"",
									GA_Disabled,	TRUE,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_COMMAND,
									GTST_String,	"",
									GA_Disabled,	TRUE,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_SAVE,
									GA_Disabled,	TRUE,
								TAG_DONE);

								LT_SetAttributes(Handle,GAD_CLEAR,
									GA_Disabled,	TRUE,
								TAG_DONE);

								TrapsChanged = FALSE;

								break;

							case GAD_REMOVE:

								if(Selected)
								{
									LT_SetAttributes(Handle,GAD_LIST,
										GTLV_Labels,	~0,
									TAG_DONE);

									if(--TrapList -> ListCount)
									{
										if(Selected -> Node . ln_Succ -> ln_Succ)
											Node = (struct TrapNode *)Selected -> Node . ln_Succ;
										else
										{
											Node = (struct TrapNode *)Selected -> Node . ln_Pred;

											Offset = 0;
										}
									}

									FreeNode((struct Node *)Selected);

									LT_SetAttributes(Handle,GAD_LIST,
										GTLV_Labels,	TrapList,
										GTLV_Selected,	Node -> Node . ln_Succ ? GetNodeOffset((struct Node *)Node,(struct List *)TrapList) : ~0,
									TAG_DONE);

									if(!TrapList -> ListCount)
									{
										Selected = NULL;

										LT_SetAttributes(Handle,GAD_TOP,
											GA_Disabled,	TRUE,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_UP,
											GA_Disabled,	TRUE,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_DOWN,
											GA_Disabled,	TRUE,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_END,
											GA_Disabled,	TRUE,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_REMOVE,
											GA_Disabled,	TRUE,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_SEQUENCE,
											GTST_String,	"",
											GA_Disabled,	TRUE,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_COMMAND,
											GTST_String,	"",
											GA_Disabled,	TRUE,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_SAVE,
											GA_Disabled,	TRUE,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_CLEAR,
											GA_Disabled,	TRUE,
										TAG_DONE);
									}
									else
									{
										Selected = Node;

										LT_SetAttributes(Handle,GAD_COMMAND,
											GTST_String,	Selected -> Command,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_SEQUENCE,
											GTST_String,	Selected -> Node . ln_Name,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_TOP,
											GA_Disabled,	!Selected -> Node . ln_Pred -> ln_Pred,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_UP,
											GA_Disabled,	!Selected -> Node . ln_Pred -> ln_Pred,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_DOWN,
											GA_Disabled,	!Selected -> Node . ln_Succ -> ln_Succ,
										TAG_DONE);

										LT_SetAttributes(Handle,GAD_END,
											GA_Disabled,	!Selected -> Node . ln_Succ -> ln_Succ,
										TAG_DONE);
									}

									TrapsChanged = TRUE;
								}

								break;

							case GAD_LIST:

								if(Selected = (struct TrapNode *)GetListNode(MsgCode,(struct List *)TrapList))
								{
									Offset = MsgCode;

									LT_SetAttributes(Handle,GAD_SEQUENCE,
										GTST_String,	Selected -> Node . ln_Name,
										GA_Disabled,	FALSE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_COMMAND,
										GTST_String,	Selected -> Command,
										GA_Disabled,	FALSE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_REMOVE,
										GA_Disabled,	FALSE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_TOP,
										GA_Disabled,	!Selected -> Node . ln_Pred -> ln_Pred,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_UP,
										GA_Disabled,	!Selected -> Node . ln_Pred -> ln_Pred,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_DOWN,
										GA_Disabled,	!Selected -> Node . ln_Succ -> ln_Succ,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_END,
										GA_Disabled,	!Selected -> Node . ln_Succ -> ln_Succ,
									TAG_DONE);
								}

								break;

							case GAD_SEQUENCE:

								if(Selected)
								{
									LT_SetAttributes(Handle,GAD_LIST,
										GTLV_Labels,	~0,
									TAG_DONE);

									Selected = ChangeTrapNode(TrapList,Selected,(STRPTR)LT_GetAttributes(Handle,GAD_SEQUENCE,TAG_DONE),NULL);

									LT_SetAttributes(Handle,GAD_LIST,
										GTLV_Labels,	TrapList,
										GTLV_Selected,	GetNodeOffset((struct Node *)Selected,(struct List *)TrapList),
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_COMMAND,
										GTST_String,	Selected -> Command,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_SEQUENCE,
										GTST_String,	Selected -> Node . ln_Name,
									TAG_DONE);

									TrapsChanged = TRUE;

									LT_Activate(Handle,GAD_COMMAND);
								}

								break;

							case GAD_COMMAND:

								if(Selected)
								{
									Selected = ChangeTrapNode(TrapList,Selected,NULL,(STRPTR)LT_GetAttributes(Handle,GAD_COMMAND,TAG_DONE));

									TrapsChanged = TRUE;
								}

								break;

							case GAD_LOAD:

								SplitFileName(LastTraps,&DummyChar,DummyBuffer);

								LT_LockWindow(LocalWindow);

								if(FileRequest = GetFile(LocalWindow,LocaleString(MSG_TRAPPANEL_LOAD_TRAP_SETTINGS_TXT),DummyBuffer,FilePart(LastTraps),DummyBuffer,"#?.prefs",FALSE,FALSE,FALSE,LocaleString(MSG_GLOBAL_LOAD_TXT),TRUE))
								{
									LT_SetAttributes(Handle,GAD_LIST,
										GTLV_Labels,	~0,
									TAG_DONE);

									Selected = NULL;

									if(!LoadTraps(DummyBuffer,TrapList))
										ShowError(LocalWindow,ERR_LOAD_ERROR,IoErr(),DummyBuffer);
									else
									{
										strcpy(LastTraps,DummyBuffer);

										TrapsChanged = FALSE;
									}

									LT_SetAttributes(Handle,GAD_LIST,
										GTLV_Labels,	TrapList,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_COMMAND,
										GTST_String,	"",
										GA_Disabled,	TRUE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_SEQUENCE,
										GTST_String,	"",
										GA_Disabled,	TRUE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_REMOVE,
										GA_Disabled,	TRUE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_TOP,
										GA_Disabled,	TRUE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_UP,
										GA_Disabled,	TRUE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_DOWN,
										GA_Disabled,	TRUE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_END,
										GA_Disabled,	TRUE,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_SAVE,
										GA_Disabled,	!TrapList -> ListCount,
									TAG_DONE);

									LT_SetAttributes(Handle,GAD_CLEAR,
										GA_Disabled,	!TrapList -> ListCount,
									TAG_DONE);

									FreeAslRequest(FileRequest);
								}

								LT_UnlockWindow(LocalWindow);

								break;

							case GAD_SAVE:

								SplitFileName(LastTraps,&DummyChar,DummyBuffer);

								LT_LockWindow(LocalWindow);

								if(FileRequest = GetFile(LocalWindow,LocaleString(MSG_TRAPPANEL_SAVE_TRAP_SETTINGS_TXT),DummyBuffer,FilePart(LastTraps),DummyBuffer,"#?.prefs",TRUE,FALSE,FALSE,LocaleString(MSG_GLOBAL_SAVE_TXT),TRUE))
								{
									if(!SaveTraps(DummyBuffer,(struct List *)TrapList))
										ShowError(LocalWindow,ERR_SAVE_ERROR,IoErr(),DummyBuffer);
									else
									{
										strcpy(LastTraps,DummyBuffer);

										TrapsChanged = FALSE;
									}

									FreeAslRequest(FileRequest);
								}

								LT_UnlockWindow(LocalWindow);

								break;
						}
					}
				}
			}
			while(!Done);

			PopWindow();
		}

		LT_DeleteHandle(Handle);
	}

	for(Node = (struct TrapNode *)TrapList -> ListHeader . mlh_Head ; Next = (struct TrapNode *)Node -> Node . ln_Succ ; Node = Next)
	{
		if(!Node -> Node . ln_Name[0] || !Node -> SequenceLen)
		{
			Remove(Node);

			FreeVecPooled(Node);

			TrapList -> ListCount--;
		}
	}

	ReleaseSemaphore(&GenericListTable[GLIST_TRAP] -> ListSemaphore);
}
